//
//  Automat.m
//  inES
//
//  Created by Sabrina Hilger on 05.02.08.
//  Copyright 2008 __MyCompanyName__. All rights reserved.
//

#import "Automat.h"
#import "MyDocument.h"

@implementation Automat

-(id)init
{
	if(self = [super init])
	{
		eListe = [[NSMutableArray alloc] init];
		uebergListe = [[NSMutableArray alloc] init];
		variablen = [[NSMutableArray alloc] init];
		memos = [[NSMutableArray alloc] init];
		zustandsnamen = [[NSMutableArray alloc] init];
		variablennamen = [[NSMutableArray alloc] init];
		feldnamen = [[NSMutableArray alloc] init];

	}
	return self;
}

- (id)initWithCoder:(NSCoder *)decoder
{
	if(self = [super init])
	{
		eListe = [[decoder decodeObjectForKey:@"inES eListe"] retain];
		uebergListe = [[decoder decodeObjectForKey:@"inES uebergListe"] retain];
		variablen = [[decoder decodeObjectForKey:@"inES variablen"] retain];
		memos = [[NSMutableArray alloc] init];
		zustandsnamen = [[decoder decodeObjectForKey:@"inES zustandsnamen"] retain];
		variablennamen = [[decoder decodeObjectForKey:@"inES variablennamen"] retain];
		feldnamen = [[decoder decodeObjectForKey:@"inES feldnamen"] retain];
	}
	return self;
}

- (void)encodeWithCoder:(NSCoder *)encoder
{
	[encoder encodeObject: eListe forKey:@"inES eListe"];
	[encoder encodeObject: uebergListe forKey:@"inES uebergListe"];
	[encoder encodeObject: variablen forKey:@"inES variablen"];
	//[encoder encodeObject: memos forKey:@"inES memos"];
	[encoder encodeObject: zustandsnamen forKey:@"inES zustandsnamen"];
	[encoder encodeObject: variablennamen forKey:@"inES variablennamen"];
	[encoder encodeObject: feldnamen forKey:@"inES feldnamen"];
}

-(void)setzeDokument:(MyDocument*)d
{
	dokument = d;
}

-(NSMutableArray*)eListe
{
	return eListe;
}

-(NSMutableArray*)uebergListe
{
	return uebergListe;
}

-(void)addMemo:(Memo*)m
{
	[memos addObject:m];
}

-(void)addName:(NSString*)n von:(NSString*)s
{
	if ([s isEqualToString:@"zustand"]) {
		[zustandsnamen addObject:n];
		return;
	}
	if ([s isEqualToString:@"variable"]){
		[variablennamen addObject:n];
		return;
	}
	if ([s isEqualToString:@"feld"]){
		[feldnamen addObject:n];
		return;
	}
}

-(void)addVariable:(Variable*)v
{
	[variablen addObject:v];
}

-(NSMutableArray*)variablen
{
	return variablen;
}

-(Memo*)memoCheck
{
	BOOL check;
	int k;
	for (k = 0; k < [memos count]; k++) {
		Memo* memo = [memos objectAtIndex:k];
		
		check = NO;
		if ([[memo befehl] isEqualToString:@"choice"] || [[memo befehl] isEqualToString:@"goto"]) {
			int i;
			for (i = 0; i < [zustandsnamen count]; i++) {
				if ([[memo inhalt] isEqualToString:[zustandsnamen objectAtIndex:i]]) {
					check = YES;
					break;
				}
			}
			if (check == NO) {
			//NSLog(@"Memo: %@", [memo description]);
				return memo;
			}
		}
		if ([[memo befehl] isEqualToString:@"clear"]) {
			int i;
			for (i = 0; i < [feldnamen count]; i++) {
				if ([[memo inhalt] isEqualToString:[feldnamen objectAtIndex:i]]) {
					check = YES;
					break;
				}
			}
			if (check == NO) {
				return memo;
			}
		}
	}
	return nil;
	
}


-(void)cleanUp
{
	[eListe removeAllObjects];
	[variablen removeAllObjects];
	[variablennamen removeAllObjects];
	[feldnamen removeAllObjects];
	[zustandsnamen removeAllObjects];
	[memos removeAllObjects];

}


-(void)delegiereAblauf
{
	NSLog(@"delegiere mit kommando %@", kommando);

	while (aktivesMElement != nil) {
		
		if ([kommando isEqualToString:@"zustandAusfuehren"]) {
			aktivesMElement = [dokument fuehreZustandAus:aktivesMElement];
		}
		if ([kommando isEqualToString:@"feldMenueAusfuehren"]) {
			[dokument fuehreFeldMenueAus:aktivesMElement];
			return;
		}
		if ([kommando isEqualToString:@"aktionBlockAusfuehren"]) {
			[dokument fuehreAktionBlockAus:aktivesMElement];
			return;
		}
		
		
		
	}

}















-(MElement*)aktivesMElement
{
	return aktivesMElement;
}

-(void)setzeKommando:(NSString*)komm
{
	[komm retain];
	[kommando release];
	kommando = komm;
}

-(void)setzeAktivesMElement:(id)m
{
	aktivesMElement = m;
}

-(void)setzeVaterVonAktivemMElement
{
	vaterVonAktivemMElement = (Formular*)aktivesMElement;
}

-(Formular*)vaterVonAktivemMElement
{
	return vaterVonAktivemMElement;
}

@end
