//
//  Block.m
//  inES
//
//  Created by Sabrina Hilger on 04.02.08.
//  Copyright 2008 __MyCompanyName__. All rights reserved.
//

#import "Block.h"
#import "MElement.h"
#import "ModelView.h"

@implementation Block

-(id)init
{
	if(self = [super init])
	{
		[self setTyp:@"Block"];
		[self setBeschreibung:@""];
		[self setBoolTitel:NO];
		[self setBoolUebergang:NO];
		[self setRect:NSMakeRect(10, 0, 95, 20)];
		uebergangListe = [[NSMutableArray alloc] init];
		[self setGemalt:NO];
		[self setAktiv:YES];
		[self setDragged:NO];
		
		aktionsbefehle = [[NSMutableArray alloc] init];
		aktiveBefehle = [[NSMutableArray alloc] init];
		ruecksetzListe = [[NSMutableArray alloc] init];
		variablen = [[NSMutableArray alloc] init];
	}
	return self;
}

- (id)initWithCoder:(NSCoder *)decoder
{
	if(self = [super initWithCoder:decoder])
	{
		uebergangListe = [[decoder decodeObjectForKey:@"inES uebergangListe"] retain];
		vater = [decoder decodeObjectForKey:@"inES vater"];

		aktionsbefehle = [[NSMutableArray alloc] init];
		variablen = [[NSMutableArray alloc] init];
	}
	return self;
}

- (void)encodeWithCoder:(NSCoder *)encoder
{
	[super encodeWithCoder:encoder];
	
	[encoder encodeObject: uebergangListe forKey:@"inES uebergangListe"];
	[encoder encodeObject: vater forKey:@"inES vater"];
}


-(NSString*)description
{
return [NSString stringWithFormat:@"Typ = %@",typ];
}

-(void)setDragged:(BOOL)b
{
	dragged = b;
}

-(void)neuerUebergang:(id)element :(NSString*)bedingung
{
	Uebergang* neu = [[Uebergang alloc] init];
	[neu setZiel:element];
	[neu setBedingung:bedingung];
	[neu setVater:self];
	[neu setStartpunkt:5];
	[uebergangListe addObject:neu];
	[[automat uebergListe] addObject:neu];
	[neu release];
}

-(void)uebergangAendern:(int)index :(NSString*)bedingung
{
	Uebergang* ueChange = [uebergangListe objectAtIndex:index];
	[ueChange setBedingung:bedingung];
	//modellview bescheid geben, dass sie sich neu ziechnen soll
	[(ModelView*)modelView setNeedsDisplay:YES];
}

-(void)setVater:(id)v
{
	vater = v;
}

-(void)setGesetzt:(BOOL)b
{
	gesetzt = b;
}


-(NSMutableArray*)uebergangListe
{
	return uebergangListe;
}

-(BOOL)dragged
{
	return dragged;
}

-(id)vater
{
	return vater;
}

-(NSString*)code
{
	NSString* code = @"<block>\n\t//Programmiere hier den anonymen Block aus.\n\n</block>";
	return code;
}

//ausfuehrung
-(void)addAktionsbefehl:(id)befehl
{
	[aktionsbefehle addObject:befehl];
	[aktiveBefehle addObject:befehl];
}

-(void)addInRuecksetzliste:(id)befehl
{
	[ruecksetzListe addObject:befehl];
}

-(NSMutableArray*)aktionsbefehle
{
	return aktionsbefehle;
}

-(NSMutableArray*)aktiveBefehle
{
	return aktiveBefehle;
}

-(void)setzeBefehleZurueck
{
	int j;
	for (j=0;j<[ruecksetzListe count]; j++) {
		[[ruecksetzListe objectAtIndex:j] setAbgespielt:NO];
	}
	[ruecksetzListe removeAllObjects];
	aktiveBefehle = aktionsbefehle;
	
}


-(void)addVariable:(Variable*)v
{
	[variablen addObject:v];
}

-(NSMutableArray*)variablen
{
	return variablen;
}

-(void)removeVariableMitName:(NSString*)name
{
	int m;
	for (m=0; m < [variablen count]; m++) {
		if ([[[variablen objectAtIndex:m] name] isEqualToString:name]) {
		//NSLog(@"retain count vor dem loeschen ist %d", [[variablen objectAtIndex:m] retainCount]);
			[variablen removeObjectAtIndex:m];
		}
	}
}

-(BOOL)gesetzt
{
	return gesetzt;
}

-(void)dealloc
{
NSLog(@"Block wird dealloc");
	[variablen release];
	[uebergangListe release];
	[aktionsbefehle release];
	[aktiveBefehle release];
	[ruecksetzListe release];
	[super dealloc];
}
@end
