//
//  Feld.m
//  inES
//
//  Created by Sabrina Hilger on 04.02.08.
//  Copyright 2008 __MyCompanyName__. All rights reserved.
//

#import "Feld.h"
#import "MElement.h"
#import "ModelView.h"

@implementation Feld

-(id)init
{
	if(self = [super init])
	{
		[self setTyp:@"Feld"];
		[self setTitel:@"ohneTitel"];
		[self setBeschreibung:@""];
		[self setAktion:@""];
		[self setBoolTitel:YES];
		[self setBoolAktion:NO];
		[self setBoolUebergang:NO];
		[self setRect:NSMakeRect(10, 0, 95, 20)];
		uebergangListe = [[NSMutableArray alloc] init];
		[self setGemalt:NO];
		[self setAktiv:YES];
		[self setDragged:NO];
		
		prompts = [[NSMutableArray alloc] init];
		options = [[NSMutableArray alloc] init];
		filled = [[Filled alloc] init];
		[self setExprTyp:@"string"];
		durchlauf = 0;
	}
	return self;
}

- (id)initWithCoder:(NSCoder *)decoder
{
	if(self = [super initWithCoder:decoder])
	{
		uebergangListe = [[decoder decodeObjectForKey:@"inES uebergangListe"] retain];
		vater = [decoder decodeObjectForKey:@"inES vater"];
		
		titel = [[decoder decodeObjectForKey:@"inES titel"] retain];
		aktion = [[decoder decodeObjectForKey:@"inES aktion"] retain];
	}
	return self;
}

- (void)encodeWithCoder:(NSCoder *)encoder
{
	[super encodeWithCoder:encoder];
	
	[encoder encodeObject: uebergangListe forKey:@"inES uebergangListe"];
	[encoder encodeObject: vater forKey:@"inES vater"];
	[encoder encodeObject: titel forKey:@"inES titel"];
	[encoder encodeObject: aktion forKey:@"inES aktion"];
}

-(NSString*)description
{
return [NSString stringWithFormat:@"Typ = %@, Titel = %@",typ,titel];
}

-(void)setTitel:(NSString*)string
{
	[string retain];
	[titel release];
	titel = string;
	[(ModelView*)modelView setNeedsDisplay:YES];
}
-(void)setAktion:(NSString*)string
{
	[aktion release];
	aktion = [string copy];
}

-(void)setDragged:(BOOL)b
{
	dragged = b;
}

-(void)neuerUebergang:(id)element :(NSString*)bedingung
{
	Uebergang* neu = [[Uebergang alloc] init];
	[neu setZiel:element];
	[neu setBedingung:bedingung];
	[neu setVater:self];
	[neu setStartpunkt:5];
	[uebergangListe addObject:neu];
	[[automat uebergListe] addObject:neu];
	[neu release];
}

-(void)uebergangAendern:(int)index :(NSString*)bedingung
{
	Uebergang* ueChange = [uebergangListe objectAtIndex:index];
	[ueChange setBedingung:bedingung];
	//modellview bescheid geben, dass sie sich neu ziechnen soll
	[(ModelView*)modelView setNeedsDisplay:YES];
}

-(void)setAktionGetroffen:(BOOL)b
{
	aktionGetroffen = b;
}

-(void)setVater:(id)v
{
	vater = v;
}

-(NSMutableArray*)uebergangListe
{
	return uebergangListe;
}

-(NSString*)titel
{
	return titel;
}

-(NSString*)aktion
{
	return aktion;
}

-(BOOL)dragged
{
	return dragged;
}

-(BOOL)aktionGetroffen
{
	return aktionGetroffen;
}

-(id)vater
{
	return vater;
}

-(NSString*)code
{
	NSString* aktionstext = @"";
	if ([self boolAktion]) {
		aktionstext = @"\t<filled>\n\t\t//Programmiere hier die Aktion.\n\n\t</filled>";
	}
	NSString* code = [NSString stringWithFormat:@"<field name=\"%@\">\n\t //Programmiere hier das Feld %@ aus.\n\n%@\n</field>",
					[self titel], [self titel], aktionstext];
	//NSLog(@"%@", code);
	return code;
}

//ausfuehrung
-(void)addPrompt:(Prompt*)p
{
	//NSLog(@"%d",[p retainCount]);
	[prompts addObject:p];
	//NSLog(@"%d",[p retainCount]);
}

-(void)addOption:(Option*)o
{
	
	[options addObject:o];
	//NSLog(@"%d",[o retainCount]);
}

-(Filled*)filled
{
	return filled;
}

-(void)setExprTyp:(NSString*)string
{
	[string retain];
	[exprTyp release];
	exprTyp = string;
}

-(void)setGesetzt:(BOOL)b
{
	gesetzt = b;
}

-(void)setExpr:(NSString*)e
{
	[e retain];
	[expr release];
	expr = e;
}

-(void)setWert:(NSString*)w
{
	[w retain];
	[wert release];
	wert = w;
}

-(NSMutableArray*)gibAktuellePrompts
{
	NSMutableArray* aktuellePrompts = [[NSMutableArray alloc] init];
	int k;
	for (k = 0; k < [prompts count]; k++) {
		Prompt* prompt = [prompts objectAtIndex:k];
		if ([prompt durchlauf] == durchlauf) {
			[aktuellePrompts addObject:prompt];
		}
	}
	[aktuellePrompts autorelease];
	return aktuellePrompts;
}

-(NSMutableArray*)options
{
	return options;
}

-(void)erhoeheDurchlauf
{
	int k;
	int maxCount = 1;
	for (k = 0; k < [prompts count]; k++) {
		Prompt* prompt = [prompts objectAtIndex:k];
		if ([prompt durchlauf] > maxCount) {
			maxCount = [prompt durchlauf];
		}
	}
	if (durchlauf < maxCount) {
		durchlauf++;
	}
}

-(void)setDurchlauf
{
	durchlauf = 0;
}

-(int)durchlauf
{
	return durchlauf;
}

-(BOOL)gesetzt
{
	return gesetzt;
}

-(NSString*)expr
{
	return expr;
}

-(NSString*)exprTyp
{
	return exprTyp;
}

-(NSString*)wert
{
	return wert;
}

-(NSString*)gibOptionfuerKommando:(NSString*)kommando
{
	int k;
	Option* op;
	for (k=0; k<[options count]; k++) {
		op = [options objectAtIndex:k];
		if ([[op string] isEqualToString:kommando]) {
			return [op value];
		}
	}
	return nil;
}


-(void)dealloc
{
	NSLog(@"Feld wird dealloc");
	[titel release];
	[aktion release];
	[uebergangListe release];
	[prompts release];
	[options release];
	[filled release];
	[exprTyp release];
	[wert release];
	[expr release];
	[super dealloc];
}
@end
