//
//  Formular.m
//  inES
//
//  Created by Sabrina Hilger on 04.02.08.
//  Copyright 2008 __MyCompanyName__. All rights reserved.
//

#import "Formular.h"
#import "MElement.h"
#import "ModelView.h"

@implementation Formular

-(id)init
{
	if(self = [super init])
	{
		[self setTyp:@"Formular"];
		[self setTitel:@"ohneTitel"];
		[self setBeschreibung:@"beschreibung"];
		[self setAktion:@""];
		[self setBoolTitel:YES];
		[self setBoolAktion:NO];
		[self setBoolUebergang:NO];
		[self setRect:NSMakeRect(0, 0, 115, 35)];
		uebergangListe = [[NSMutableArray alloc] init];
		feldliste = [[NSMutableArray alloc] init];
		//anlaeufer = [[NSMutableArray alloc] init];
		//[self neuerUebergang:self :@"beschreibung"];
		//[self neuerUebergang:self :@"zweiter"];
		[self setGemalt:NO];
		[self setAktiv:YES];
		filled = [[Filled alloc] init];
		variablen = [[NSMutableArray alloc] init];
		feldvariablen = [[NSMutableArray alloc] init];
	}
	return self;
}


- (id)initWithCoder:(NSCoder *)decoder
{
	if(self = [super initWithCoder:decoder])
	{
		uebergangListe = [[decoder decodeObjectForKey:@"inES uebergangListe"] retain];
		feldliste = [[decoder decodeObjectForKey:@"inES feldliste"] retain];
		titel = [[decoder decodeObjectForKey:@"inES titel"] retain];
		aktion = [[decoder decodeObjectForKey:@"inES aktion"] retain];
	}
	return self;
}

- (void)encodeWithCoder:(NSCoder *)encoder
{
	[super encodeWithCoder:encoder];
	
	[encoder encodeObject: uebergangListe forKey:@"inES uebergangListe"];
	[encoder encodeObject: feldliste forKey:@"inES feldliste"];
	[encoder encodeObject: titel forKey:@"inES titel"];
	[encoder encodeObject: aktion forKey:@"inES aktion"];
	[encoder encodeBool: aktionGetroffen forKey:@"inES aktionGetroffen"];
}



-(NSString*)description
{
return [NSString stringWithFormat:@"Typ = %@, Titel = %@, anz vars = %d",typ,titel,[variablen count]];
}

//noch nicht benutzt
-(void)setzeDokument:(NSDocument*)d
{
	dokument = d;
}

-(void)setTitel:(NSString*)string
{
	[string retain];
	[titel release];
	titel = string;
	//modellview bescheid geben, dass sie sich neu ziechnen soll
	[(ModelView*)modelView  setNeedsDisplay:YES];

}
-(void)setAktion:(NSString*)string
{
	[aktion release];
	aktion = [string copy];
}
-(void)neuerUebergang:(id)element :(NSString*)bedingung
{
	Uebergang* neu = [[Uebergang alloc] init];
	[neu setZiel:element];
	[neu setBedingung:bedingung];
	[neu setVater:self];
	[neu setStartpunkt:8];
	[uebergangListe addObject:neu];
	[[automat uebergListe] addObject:neu];
	[neu release];
}

-(void)uebergangAendern:(int)index :(NSString*)bedingung
{
	Uebergang* ueChange = [uebergangListe objectAtIndex:index];
	[ueChange setBedingung:bedingung];
	//modellview bescheid geben, dass sie sich neu ziechnen soll
	[(ModelView*)modelView setNeedsDisplay:YES];
}

-(void)addFormitem:(id)formItem
{
	//feld in liste einfuegen und nr(position auf formular) geben
	[feldliste addObject:formItem];
}

-(void)setAktionGetroffen:(BOOL)b
{
	aktionGetroffen = b;
}

-(NSMutableArray*)uebergangListe
{
	return uebergangListe;
}

-(NSMutableArray*)feldliste
{
	return feldliste;
}

-(MElement*)letztesFormitem
{
	int k = [feldliste count];
	if (k != 0) {
		return [feldliste objectAtIndex:k - 1];
	}
	return nil;
}

-(NSString*)titel
{
	return titel;
}

-(NSString*)aktion
{
	return aktion;
}

-(BOOL)aktionGetroffen
{
	return aktionGetroffen;
}

-(NSString*)code
{
	NSString* aktionstext = @"";
	if ([self boolAktion]) {
		aktionstext = @"\t<filled>\n\t\t//Programmiere hier die Aktion.\n\n\t</filled>";
	}
	NSString* code = [NSString stringWithFormat:@"<form id=\"%@\">\n\t//Fuege hier die Formularelemente von %@ ein.\n\n%@\n</form>",
					[self titel], [self titel], aktionstext];
//	NSLog(@"%@", code);
	return code;
}

-(Filled*)filled
{
	return filled;
}

-(void)addVariable:(Variable*)v
{
	[variablen addObject:v];
}

-(NSMutableArray*)variablen
{
	return variablen;
}

-(void)addFeldvariable:(Variable*)v
{
	[feldvariablen addObject:v];
}

-(NSMutableArray*)feldvariablen
{
	return feldvariablen;
}

-(void)clearAll
{
	[filled setGesetzt:NO];
	int k;
	Feld* feld;
	Filled* feldFilled;
	for (k=0; k< [feldliste count]; k++) {
		feld = [feldliste objectAtIndex:k];
		[feld setGesetzt:NO];
		if ([feld boolAktion] == YES) {
			feldFilled = [feld filled];
			[feldFilled setGesetzt:NO];	
		}	
		int m;
		for (m=0; m < [variablen count]; m++) {
			[[variablen objectAtIndex:m] setGesetzt:NO];
		}
	}
	[feldvariablen removeAllObjects];
//NSLog(@"anz feldvariablen des forms %d", [feldvariablen count]);
}

-(void)removeFeldvariableMitName:(NSString*)name
{
	int k;
	for (k=0; k < [feldvariablen count]; k++) {
		if ([[[feldvariablen objectAtIndex:k] name] isEqualToString:name]) {
			[feldvariablen removeObjectAtIndex:k];
			return;
		}
	}
}

-(void)dealloc
{
	NSLog(@"Form wird dealloc");
	[titel release];
	[aktion release];
	[uebergangListe release];
	[feldliste release];
	[filled release];
	[variablen release];
	[super dealloc];
}
@end
