//
//  Menu.m
//  inES
//
//  Created by Sabrina Hilger on 04.02.08.
//  Copyright 2008 __MyCompanyName__. All rights reserved.
//

#import "Menu.h"
#import "MElement.h"
#import "ModelView.h"

@implementation Menu

-(id)init
{
	if(self = [super init])
	{
		[self setTyp:@"Menue"];
		[self setTitel:@"ohneTitel"];
		[self setBeschreibung:@""];
		[self setBoolTitel:YES];
		[self setBoolAktion:NO];
		[self setBoolUebergang:NO];
		[self setRect:NSMakeRect(0, 0, 110, 35)];
		uebergangListe = [[NSMutableArray alloc] init];
		[self setGemalt:NO];
		[self setAktiv:YES];
		
		prompts = [[NSMutableArray alloc] init];
		choices = [[NSMutableArray alloc] init];
	}
	return self;
}


- (id)initWithCoder:(NSCoder *)decoder
{
	if(self = [super initWithCoder:decoder])
	{
		titel = [[decoder decodeObjectForKey:@"inES titel"] retain];
		uebergangListe = [[decoder decodeObjectForKey:@"inES uebergangListe"] retain];

		prompts = [[NSMutableArray alloc] init];
		choices = [[NSMutableArray alloc] init];
	}
	return self;
}

- (void)encodeWithCoder:(NSCoder *)encoder
{
	[super encodeWithCoder:encoder];
	
	[encoder encodeObject: titel forKey:@"inES titel"];
	[encoder encodeObject: uebergangListe forKey:@"inES uebergangListe"];
}

-(NSString*)description
{
return [NSString stringWithFormat:@"Typ = %@, Titel = %@",typ,titel];
}

-(void)setTitel:(NSString*)string
{
	[string retain];
	[titel release];
	titel = string;
	//modellview bescheid geben, dass sie sich neu ziechnen soll
	[(ModelView*)modelView setNeedsDisplay:YES];
}

-(void)neuerUebergang:(id)element :(NSString*)bedingung
{
	Uebergang* neu = [[Uebergang alloc] init];
	[neu setZiel:element];
	[neu setBedingung:bedingung];
	[neu setVater:self];
	[neu setStartpunkt:7];
	[uebergangListe addObject:neu];
	[[automat uebergListe] addObject:neu];
	[neu release];
}

-(void)uebergangAendern:(int)index :(NSString*)bedingung
{
	Uebergang* ueChange = [uebergangListe objectAtIndex:index];
	[ueChange setBedingung:bedingung];
	//modellview bescheid geben, dass sie sich neu ziechnen soll
	[(ModelView*)modelView setNeedsDisplay:YES];
}


-(NSMutableArray*)uebergangListe
{
	return uebergangListe;
}

-(NSString*)titel
{
	return titel;
}

-(NSString*)code
{
	NSString* code = [NSString stringWithFormat:@"<menu id=\"%@\">\n\t//Programmiere hier das Menue %@ aus.\n\n</menu>",
					[self titel], [self titel]];
//NSLog(@"%@", code);
	return code;
}


//ausfuehrung
-(void)addPrompt:(Prompt*)p
{
	[prompts addObject:p];
}

-(void)addChoice:(Choice*)c
{
	[choices addObject:c];
}

-(void)erhoeheDurchlauf
{
	int k;
	int maxCount = 1;
	for (k = 0; k < [prompts count]; k++) {
		Prompt* prompt = [prompts objectAtIndex:k];
		if ([prompt durchlauf] > maxCount) {
			maxCount = [prompt durchlauf];
		}
	}
	if (durchlauf < maxCount) {
		durchlauf++;
	}
}

-(void)setDurchlauf
{
	durchlauf = 0;
}

-(int)durchlauf
{
	return durchlauf;
}

-(NSMutableArray*)choices
{
	return choices;
}

-(NSMutableArray*)gibAktuellePrompts
{
	NSMutableArray* aktuellePrompts = [[NSMutableArray alloc] init];
	int k;
	for (k = 0; k < [prompts count]; k++) {
		Prompt* prompt = [prompts objectAtIndex:k];
		if ([prompt durchlauf] == durchlauf) {
			[aktuellePrompts addObject:prompt];
		}
	}
	[aktuellePrompts autorelease];
	return aktuellePrompts;
}

-(void)dealloc
{
	NSLog(@"Menue wird dealloc");
	[titel release];
	[uebergangListe release];
	[prompts release];
	[choices release];
	[super dealloc];
}
@end
