#import "ModelView.h"

@implementation ModelView

#pragma mark Initialisierung und Variablen

- (id)initWithFrame:(NSRect)frameRect
{
	if ((self = [super initWithFrame:frameRect]) != nil) {
		i = 0;
		attrk = [[NSMutableDictionary alloc] init];
		[attrk setObject:[NSFont fontWithName:@"Helvetica" size:11]
								forKey:NSFontAttributeName];
		[attrk setObject:[NSColor blackColor]
								forKey:NSForegroundColorAttributeName];
								
		attrbg = [[NSMutableDictionary alloc] init];
		[attrbg setObject:[NSFont fontWithName:@"Helvetica-Bold" size:12]
								forKey:NSFontAttributeName];
		[attrbg setObject:[NSColor blackColor]
								forKey:NSForegroundColorAttributeName];
								
		attrbk = [[NSMutableDictionary alloc] init];
		[attrbk setObject:[NSFont fontWithName:@"Helvetica-Bold" size:11]
								forKey:NSFontAttributeName];
		[attrbk setObject:[NSColor blackColor]
								forKey:NSForegroundColorAttributeName];
		attrd = [[NSMutableDictionary alloc] init];
		[attrd setObject:[NSFont fontWithName:@"Helvetica" size:11]
								forKey:NSFontAttributeName];
		[attrd setObject:[NSColor colorWithDeviceRed:0.3 green:0.3 blue:0.3 alpha:0.3]
								forKey:NSForegroundColorAttributeName];
		
		aktiveElemente = [[NSMutableArray alloc] init];
		anfasserListe = [[NSMutableArray alloc] init];
		//aktivesFeld = [[Feld alloc] init];
		uebergangscounter = -1;
		anfasserGetroffen = NO;
	}
	return self;
}

-(void)setAutomat:(Automat*)a
{
	automat = a;
}

-(void)setDokument:(NSDocument*)d
{
	dokument = d;
}

-(NSPoint)viewKoord:(NSEvent*)theEvent
{
   //hier wird die mauskoordinate in modelView ermittelt. im event steckt nur die window-koordinate
   NSPoint p = [theEvent locationInWindow];
  p.x -= ([self frame].origin.x +[[self superview] frame].origin.x +[[[self superview] superview] frame].origin.x);
   p.y -= ([self frame].origin.y +[[self superview] frame].origin.y +[[[self superview] superview] frame].origin.y);
   return p;
}

#pragma mark Methoden, auf die die Elemente und MyDocument zugreifen

-(id)gibAktivesElement
{
	if ([aktiveElemente count]==0) {
		if ([aktivesFeld aktiv]) {
			return aktivesFeld;
		}
		else {
			return nil;
		}
	}
	else {
		if ([aktiveElemente count] > 1) {
			return nil;
		}
		else {
			//NSLog(@"getroffen");
			return [aktiveElemente objectAtIndex:0];
		}
	}
}

-(BOOL)neuesFormitemErlaubt
{
	if ([aktiveElemente count]==0) {
		return NO;
	}
	else {
		id element = [aktiveElemente objectAtIndex:0];
		//NSLog(@"aktiveElemente count = %d", [aktiveElemente count]);
		if (([aktiveElemente count]==1) && [[element typ] isEqualToString:@"Formular"]) {
			vaterVonAktivemFeld = element;
			[vaterVonAktivemFeld setAktiv:NO];
			return YES;
		}
		else {
			return NO;
		}
	}
}

-(BOOL)neueAktionErlaubt
{

	BOOL aktiveAktion;
	if ([aktiveElemente count]==0) {
		if ([[aktivesFeld typ] isEqualToString:@"Feld"]) {
			aktiveAktion = [aktivesFeld boolAktion];
			if (aktiveAktion) {
				//NSLog(@"Feld hat bereits eine Aktion");
				return NO;
			}
			else {
				[aktivesFeld setBoolAktion:YES];
				//NSLog(@"Feld bekommt Aktion");
				[(MyDocument*)dokument oeffneModellPanel:aktivesFeld:NO aktion:NO];
				return YES;
			}
		}
		else {
			//NSLog(@"Block kann keine Aktion besitzen");
			return NO;
		}
		

	}
	else {
		//NSLog(@"aktive elemente nicht null, insges %d", [aktiveElemente count]);
		id form = [aktiveElemente objectAtIndex:0];
		if (([aktiveElemente count]==1) && [[form typ] isEqualToString:@"Formular"]) {
			aktiveAktion = [form boolAktion];
			if (aktiveAktion == YES) {
				//NSLog(@"Formular hat bereits eine Aktion");
				return NO;
			}
			else {
				[form setBoolAktion:YES];
				//NSLog(@"Formular bekommt eine Aktion");
				[(MyDocument*)dokument oeffneModellPanel:form:NO aktion:YES];
				return YES;
			}
		}
		else {
			//NSLog(@"Element kann keine Aktion besitzen");
			return NO;
		}
	}
}

-(id)vaterVonAktivemFeld
{
	return vaterVonAktivemFeld;
}

-(void)neuesElement:(id)element
{
	[self resetAktiveElemente];
	[aktivesFeld setAktiv:NO];
	if([[element typ] isEqualToString:@"Feld"] || [[element typ] isEqualToString:@"Block"]){
		aktivesFeld = element;
	} else {
		[aktiveElemente addObject:element];
		//[element release];
		//NSLog(@"anz aktiver Elemente %d", [aktiveElemente count]);
	}
	//[[self window] setAcceptsMouseMovedEvents:NO];
	[self setNeedsDisplay:YES];
	[(MyDocument*)dokument oeffneModellPanel:element:NO aktion:NO];
	
}

-(BOOL)neuerUebergangErlaubt
{
	if ([aktiveElemente count] > 1) {
		return NO;
	}
	else {
		if ([aktivesFeld aktiv]) {
			vaterVonAktivemUebergang = aktivesFeld;
			return YES;
		}
		else {
			if ([aktiveElemente count] == 1) {
				vaterVonAktivemUebergang = [aktiveElemente objectAtIndex:0];
				return YES;
			}
			else {
				return NO;
			}
		}
	}
}

-(void)setUebergangSetzen:(BOOL)b
{
	uebergangSetzen = b;
}


-(void)setUebergangscounter:(int)zahl
{
	uebergangscounter = zahl;
}

-(void)resetAktiveElemente
{
	int k;

	for (k = 0; k < [aktiveElemente count]; k++) {
		[[aktiveElemente objectAtIndex:k] setAktiv:NO];
	}
	[aktiveElemente removeAllObjects];



}

#pragma mark mouse-events
-(void)mouseDown:(NSEvent*)event
{
	BOOL doppelklick;
	NSPoint p;
	getroffen = NO;
	feldGetroffen = NO;
	[aktivesFeld setAktiv:NO];
	if ([[aktivesFeld typ] isEqualToString:@"Feld"]) {
		[aktivesFeld setAktionGetroffen:NO];
	}
	if ([[getroffenesElement typ] isEqualToString:@"Formular"]) {
		[getroffenesElement setAktionGetroffen:NO];
	}
	p = [self convertPoint:[event locationInWindow] fromView: nil];
	altePos = p;
	eListe = [automat eListe];
	id element;
	unsigned int shift = [event modifierFlags];
	NSRect rect;
	
	//wurde anfasser getroffen?
	Anfasser* anfasser;
	int m;
	for (m=0; m < [anfasserListe count]; m++) {
		anfasser = [anfasserListe objectAtIndex:m];
		rect = [anfasser anfRect];
			//NSLog(@"anfasser raushlen udn pruefen");
		if ((rect.origin.x <= p.x) && (p.x <= rect.origin.x + rect.size.width) && 
		(rect.origin.y <= p.y) && (p.y <= rect.origin.y + rect.size.height)) {

			anfasserGetroffen = YES;
			[anfasser setAktiv:YES];
			//NSLog(@"eins auf aktiv");
			break;
		}
	}
	
	if (anfasserGetroffen == NO) {
	//NSLog(@"anfasser = no");

		//wurde elemente getroffen?
		for (i=0; i < [eListe count]; i++) {
			element = [eListe objectAtIndex:i];
			rect = [element rect];
				
			if ((rect.origin.x <= p.x) && (p.x <= rect.origin.x + rect.size.width) &&
				(rect.origin.y <= p.y) && (p.y <= rect.origin.y + rect.size.height)) {
				getroffenesElement = element;
				getroffen = YES;
				//NSLog(@"%@", [getroffenesElement description]);
			}
		}
		
		//wurde formular getroffen
		if ([[getroffenesElement typ] isEqualToString:@"Formular"]) {
			
			NSRect formRect = [getroffenesElement rect];

			//wurde eine aktion vom formular getroffen?
			if ([getroffenesElement boolAktion]) {
				//formRect umrechnen zu aktionsRect
				NSRect formRectC = formRect;
				formRectC.origin.x += 67;
				formRectC.origin.y += 3;
				formRectC.size.width  = 45;
				formRectC.size.height = 18;
				if ((formRectC.origin.x <= p.x) && (p.x <= formRectC.origin.x + formRectC.size.width) && 
					(formRectC.origin.y <= p.y) && (p.y <= formRectC.origin.y + formRectC.size.height)) {
					
					[getroffenesElement setAktionGetroffen:YES];
				}
			}

			//wurde feld getroffen?
			//p in bezug zum origin vom formular ausrechnen
			p.x -= formRect.origin.x;
			p.y -= formRect.origin.y;
			//NSLog(@"getroffener Punkt %f %f", p.x, p.y);
					
			Feld* feld;
			feldliste = [getroffenesElement feldliste];
			int j = 0;
			while (j < [feldliste count]) {
				feld = [feldliste objectAtIndex:j];
				rect = [feld rect];
				//rect.origin.
				if ((rect.origin.x <= p.x) && (p.x <= rect.origin.x + rect.size.width) && 
					(rect.origin.y <= p.y) && (p.y <= rect.origin.y + rect.size.height)) {
							
					vaterOrigin = [getroffenesElement rect].origin;
					/////
					aktivesFeld = feld;
					vaterVonAktivemFeld = getroffenesElement;
					feldGetroffen = YES;
					//wurde aktion getroffen?
					if ([[aktivesFeld typ] isEqualToString:@"Feld"] && [aktivesFeld boolAktion]) {
						rect.origin.x += 47;
						rect.origin.y += 3;
						rect.size.width = 45;
						rect.size.height = 18;
						if ((rect.origin.x <= p.x) && (p.x <= rect.origin.x + rect.size.width) && 
							(rect.origin.y <= p.y) && (p.y <= rect.origin.y + rect.size.height)) {
						
							[aktivesFeld setAktionGetroffen:YES];
							//[aktivesFeld setAktiv:NO];
						}
					}

				}
				j++;
			}
		}//ende formular
		
		//uebergang wird gerade gesetzt
		if (uebergangSetzen) {
			if (getroffen == YES) {
				//wenn getr form oder menu = ziel ist
				BOOL alleOK = YES;
				if (![getroffenesElement isEqual:vaterVonAktivemUebergang]) {
					//wenn es menu ist
					if ([[getroffenesElement typ] isEqualToString:@"Formular"]) {
						//wenn es form ist
						////wenn feld oder block vater ist, dann darf das vaterformular nicht = dem getr sein
						feldliste = [getroffenesElement feldliste];
						int k;
						Feld* einFeld;
						
						for (k = 0; k < [feldliste count]; k++) {
							einFeld = [feldliste objectAtIndex:k];
							if (einFeld == vaterVonAktivemUebergang) {
								alleOK = NO;
							}
						}
					}
					if (alleOK) {
						//NSLog(@"ziel ist in ordnung");
						[vaterVonAktivemUebergang neuerUebergang:getroffenesElement :@"Eingabe"];
						[vaterVonAktivemUebergang setBoolUebergang:YES];
						[(MyDocument*)dokument oeffneModellPanel:vaterVonAktivemUebergang:YES aktion:NO];
						
						[self resetAktiveElemente];
						if (([[vaterVonAktivemUebergang typ] isEqualToString:@"Formular"]) ||
							([[vaterVonAktivemUebergang typ] isEqualToString:@"Menue"])) {
							[aktiveElemente addObject:vaterVonAktivemUebergang];
						}
						else {
							aktivesFeld = vaterVonAktivemUebergang;
						}
						[vaterVonAktivemUebergang setAktiv:YES];
					}
				}
				else {
					//NSLog(@"er kann nicht selbst ziel sein");
				}
			}
			else {
				//NSLog(@"nichts getroffen");
				[self resetAktiveElemente];
			}
		}
		else {//nicht moved und uebergang
		
			if ([event clickCount]==1) {//a
				doppelklick = NO;
				//NSLog(@"einfacher klcik");
				if (getroffen == YES) {//b
					if ([getroffenesElement aktiv]) {
						//wenn ja, ist Shift an?
						//NSLog(@"getroffenes element ist aktiv");
						if (shift & NSShiftKeyMask) {
							[getroffenesElement setAktiv:NO];
							//aktiveElementeListe neu setzen
							[aktiveElemente removeObject:getroffenesElement];
							if ([aktiveElemente count] == 1) {
								[(MyDocument*)dokument oeffneModellPanel:[aktiveElemente objectAtIndex:0]:NO aktion:NO];
							}
						}
						else {
							//NSLog(@"kein shift");
							//ob feld getroffen, dann formular aus und feld an
							if (feldGetroffen == YES) {
								[self resetAktiveElemente];
								[getroffenesElement setAktiv:NO];
								
								//aktion getroffen?
								BOOL drin = NO;
								if([[aktivesFeld typ] isEqualToString:@"Feld"] && [aktivesFeld boolAktion]) {
									if ([aktivesFeld aktionGetroffen]) {
										[(MyDocument*)dokument oeffneModellPanel:aktivesFeld:doppelklick aktion:YES];
										drin = YES;
									}
								}
								if (drin == NO) {
									[aktivesFeld setAktiv:YES];
									//NSLog(@" %@", [aktivesFeld description]);
									[(MyDocument*)dokument oeffneModellPanel:aktivesFeld:doppelklick aktion:NO];
								}		
							//aktion eines formulars getroffen?
							} else if ([[getroffenesElement typ] isEqualToString:@"Formular"]) {
								if ([getroffenesElement aktionGetroffen]) {
									[self resetAktiveElemente];
									[getroffenesElement setAktiv:NO];
									[getroffenesElement setAktionGetroffen:YES];
									[(MyDocument*)dokument oeffneModellPanel:getroffenesElement:doppelklick aktion:YES];
								}
							}
						}
					} else {//m
						//element noch nicht aktiv
						//NSLog(@"element noch nicht aktiv");
						//ist shift an? fuege zur aktivliste hinzu
						if (shift & NSShiftKeyMask) {
							// und falls vorher feld markiert, dann unaktiv und vater aktiv
							if ([aktiveElemente count] == 0) {
								[aktiveElemente addObject:vaterVonAktivemFeld];
								[vaterVonAktivemFeld setAktiv:YES];
							}
							//ist getroE schon in liste, weil es gleich dem vater sein koennte? wenn nein, dann
							BOOL schonDrin = [aktiveElemente containsObject:getroffenesElement];
							if (schonDrin == NO) {
								[aktiveElemente addObject:getroffenesElement];
								[getroffenesElement setAktiv:YES];
								[(MyDocument*)dokument setzeMehrfachPanel];
							}
							else {
								[(MyDocument*)dokument oeffneModellPanel:vaterVonAktivemFeld:doppelklick aktion:NO];
							}
							//NSLog(@"anzahl aktiver Elemente %d", [aktiveElemente count]);
							
						} 
						else {
							//NSLog(@"ohne shift");
							//ohne shift werden alle aktiven nichtaktiv, nur das neue
							[self resetAktiveElemente];
							//NSLog(@"anzahl der getroffenen Elemente soll null sein, ist %d", [aktiveElemente count]);
							if (feldGetroffen) {
								//NSLog(@"formitem getroffen");
								BOOL drinGewesen = NO;
								if ([[aktivesFeld typ] isEqualToString:@"Feld"] && [aktivesFeld boolAktion]) {
								//	NSLog(@"feld %@",[aktivesFeld description]);
									if ([aktivesFeld aktionGetroffen]) {
										[(MyDocument*)dokument oeffneModellPanel:aktivesFeld:doppelklick aktion:YES];
										drinGewesen = YES;
									}
								}
								if (drinGewesen == NO) {
									//NSLog(@"feld aktivieren");
									[aktivesFeld setAktiv:YES];
									[(MyDocument*)dokument oeffneModellPanel:aktivesFeld:doppelklick aktion:NO];
								}
							} else {
								BOOL durch = NO;
								if ([[getroffenesElement typ] isEqualToString:@"Formular"]) {
									if ([getroffenesElement aktionGetroffen]) {
										[getroffenesElement setAktionGetroffen:YES];
										[(MyDocument*)dokument oeffneModellPanel:getroffenesElement:doppelklick aktion:YES];
										durch = YES;
									} 
								}
								if (durch == NO) {
									[aktiveElemente addObject:getroffenesElement];
									[getroffenesElement setAktiv:YES];
									[(MyDocument*)dokument oeffneModellPanel:getroffenesElement:doppelklick aktion:NO];
								}
							}
						}
					}//m
				} //b nichts getroffen
				else {
					if (!(shift & NSShiftKeyMask)){
						//NSLog(@"ohne shift nichts getroffen");
						//ohne shift werden alle nichtaktiv
						[self resetAktiveElemente];
						//NSLog(@"anzahl der getroffenen Elemente soll null sein, ist %d", [aktiveElemente count]);
					}else {
						//NSLog(@"nichts passiert");
					}
			}
			}else {//Doppelklick
				doppelklick = YES;
				[self resetAktiveElemente];
				if (feldGetroffen) {
					[aktivesFeld setAktiv:YES];
					[(MyDocument*)dokument oeffneModellPanel:aktivesFeld :doppelklick aktion:NO];
				} else {//wenn  feld dann
					[aktiveElemente addObject:getroffenesElement];
					[getroffenesElement setAktiv:YES];
					[(MyDocument*)dokument oeffneModellPanel:getroffenesElement :doppelklick aktion:NO];
				}
			}//Doppelklick
		}
	[self setNeedsDisplay:YES];
	}
}

-(void)mouseDragged:(NSEvent*)event
{
	NSPoint p;
	p = [self convertPoint:[event locationInWindow] fromView: nil];
	NSRect recht;
	id element;
	//NSLog(@"dragged");
	if (anfasserGetroffen == NO) {
		//NSLog(@"anfasserGetroffen == NO");
		//koordinaten von dem getroffenen element aendern
		

		for (i=0; i < [aktiveElemente count]; i++) {
			element = [aktiveElemente objectAtIndex:i];
			recht = [element rect];
			recht.origin.x = recht.origin.x + p.x - altePos.x;
			recht.origin.y = recht.origin.y + p.y - altePos.y;
			[element setRect:recht];
		}
		//wenn nur das feld aktiv ist und gedragged wird, dann verschieben
		if (([aktiveElemente count] == 0) && (feldGetroffen == YES) && ([aktivesFeld aktiv])){
			//male eine feldkopie an den mauszeiger bei altePos
			[aktivesFeld setDragged:YES];
		}
	} else {
		[self resetAktiveElemente];
		//wenn anfasser getroffen wurde
		Anfasser* anfasser;
		for (i=0; i < [anfasserListe count]; i++) {
			//NSLog(@"geht rein");
			
			anfasser = [anfasserListe objectAtIndex:i];
			if ([anfasser aktiv] == YES) {
				NSRect vaterR = [[anfasser vater] rect];
				if (([[[anfasser vater] typ] isEqualToString:@"Feld"]) ||
					([[[anfasser vater] typ] isEqualToString:@"Block"])) {
					
					NSPoint relativZurView = [[[anfasser vater] vater] rect].origin;
					vaterR.origin.x += relativZurView.x;
					vaterR.origin.y += relativZurView.y;
				}
				//NSLog(@"%@", [[anfasser vater] description]);
				float breite = vaterR.size.width / 2;
				float hoehe = vaterR.size.height / 2;
				NSRect sensFeld = NSMakeRect(vaterR.origin.x - breite / 2,vaterR.origin.y - hoehe / 2 + vaterR.size.height,breite,hoehe);
				BOOL neuePosition = [self istPunkt:p inRechteck:sensFeld];
				if (neuePosition == YES) {
					[anfasser neuePosition:1];
					//NSLog(@"pos 1");
				}
				else {
					sensFeld.origin.x += breite;
					neuePosition = [self istPunkt:p inRechteck:sensFeld];
					if (neuePosition) {
						[anfasser neuePosition:2];
						//NSLog(@"pos 2");
					}
					else {
						sensFeld.origin.x += breite;
						neuePosition = [self istPunkt:p inRechteck:sensFeld];
						if (neuePosition) {
							[anfasser neuePosition:3];
							//NSLog(@"pos 3");
						}
						else {
							sensFeld.origin.y -= hoehe;
							neuePosition = [self istPunkt:p inRechteck:sensFeld];
							if (neuePosition) {
								[anfasser neuePosition:5];
								//NSLog(@"pos 5");
							}
							else {
								sensFeld.origin.y -= hoehe;
								neuePosition = [self istPunkt:p inRechteck:sensFeld];
								if (neuePosition) {
									[anfasser neuePosition:8];
									//NSLog(@"pos 8");
								}
								else {
									sensFeld.origin.x -= breite;
									neuePosition = [self istPunkt:p inRechteck:sensFeld];
									if (neuePosition) {
										[anfasser neuePosition:7];
										//NSLog(@"pos 7");
									}
									else {
										sensFeld.origin.x -= breite;
										neuePosition = [self istPunkt:p inRechteck:sensFeld];
										if (neuePosition) {
											[anfasser neuePosition:6];
											//NSLog(@"pos 6");
										}
										else {
											sensFeld.origin.y += hoehe;
											neuePosition = [self istPunkt:p inRechteck:sensFeld];
											if (neuePosition) {
												[anfasser neuePosition:4];
												//NSLog(@"pos 4");
											}
										}
									}
								}
							}
						}
					}
				}
			}
		}
	}
	
	
	//view soll sich neu zeichnen
	[self setNeedsDisplay:YES];
	
	//alte position fuer neue Berechnung
	altePos = p;
}

-(BOOL)istPunkt:(NSPoint)p inRechteck:(NSRect)rect
{
	if ((rect.origin.x <= p.x) && (p.x <= rect.origin.x + rect.size.width) && 
	(rect.origin.y <= p.y) && (p.y <= rect.origin.y + rect.size.height)) {

		return YES;
	} else {
		return NO;
	}
}

-(void)mouseUp:(NSEvent*)event
{
	//NSLog(@"mouseUp");
	if ([aktivesFeld dragged]) {
		[aktivesFeld setDragged:NO];
		if (positionFeld != -1) {
		//NSLog(@"mouseUp");
			NSMutableArray* liste = [vaterVonAktivemFeld feldliste];
			int index = [liste indexOfObject:aktivesFeld];
			if (index < positionFeld) {
				[liste removeObject:aktivesFeld];
				[liste insertObject:aktivesFeld atIndex:positionFeld-1];
			}
			else {
				[liste removeObject:aktivesFeld];
				[liste insertObject:aktivesFeld atIndex:positionFeld];
			}
		}
		[self setNeedsDisplay:YES];
	}
	
	//uebergang setzen
	if (anfasserGetroffen == YES) {
		anfasserGetroffen = NO;
	}
	
	//NSLog(@"moved wieder no");
	uebergangSetzen = NO;
	[[self window] setAcceptsMouseMovedEvents:NO];
	[self setNeedsDisplay:YES];
	[anfasserListe removeAllObjects];
}

-(void)mouseMoved:(NSEvent*)event
{
	
	movedPoint = [self convertPoint:[event locationInWindow] fromView: nil];
	//moved = YES;
	//NSLog(@"moevmethode");
	[self setNeedsDisplay:YES];
}

#pragma mark zeichne-methode
//methode bekommt das rechteck mit, dass neu gezeichnet werden muss
//aufrufen der methode ueber setNeedsDisplay:YES oder setNeedsDisplayInRect
- (void)drawRect:(NSRect)rect
{
	
	id element;

	//NSLog(@"\n view malt");
	positionFeld = -1;
	//ganze view wird weiss
	[[NSColor whiteColor] set];
	[NSBezierPath fillRect: rect];
	
	//aktuellen automaten holen
	eListe = [automat eListe];
	int anzahl = [eListe count];
	//NSLog(@"anzahl der zustaende in liste %d", anzahl);
	
	
	//jedes element wird in seine zeichne-routine geschickt
	
	for (i = 0; i < anzahl; i++) {
		element = [eListe objectAtIndex:i];
		
		if ([[element typ] isEqualToString:@"Formular"]) {
		//	NSLog(@"formular %f %d", [element rect].origin.x, [eListe count]);
			[self formularDesign:element];
		}
		else {
			//NSLog(@"menu");
			[self menuDesign:element];
		}
	}
	if ([aktivesFeld dragged]) {
		[self feldDesign:aktivesFeld :vaterVonAktivemFeld :YES];
	}
	//NSLog(@"%d", (int)moved);
	if (uebergangSetzen) {
		NSString* movedString = @"SETZE ZIELZUSTAND";
		movedPoint.y -= 25;
		[movedString drawAtPoint:movedPoint withAttributes:attrd];
	}
	
	uebergListe = [automat uebergListe];
	for (i = 0; i < [uebergListe count]; i++) {
		//NSLog(@"%@",[[uebergListe objectAtIndex:i] description]);
		[self uebergangDesign:[uebergListe objectAtIndex:i]];
	}
	
}

-(void)formularDesign:(Formular*)element
{
	NSRect rechteck;
	NSRect feldrechteck;
	NSBezierPath* strich;
	NSPoint p;
	id einFeld;
	NSMutableArray* eineFeldliste;
	//position und groesse des Formulars
	rechteck = [element rect];
	float obenlinks;
	//wird es das erste mal gezeichnet?
	if ([element gemalt] == NO) {
		NSRect view = [self bounds];
		rechteck.origin.x = view.size.width / 2;
		rechteck.origin.y = view.size.height / 2;
		//[element setRect:rechteck];
		[element setGemalt:YES];
	}
	obenlinks = rechteck.origin.y + rechteck.size.height;	
	//groesser veraendern je nach dem welche felder drin sind, und felder entsprechend setzen
	eineFeldliste = [element feldliste];
	if ([eineFeldliste count]==0) {
		rechteck.size.height = 35;
	}
	else {
		//NSLog(@"felder setzen");
		int k = 25;
		int wham;
		for (wham = 0; wham < [eineFeldliste count]; wham++) {
			einFeld = [eineFeldliste objectAtIndex:wham];
			feldrechteck = [einFeld rect];
			feldrechteck.origin.y = k + feldrechteck.size.height;//25 + 20;
			[einFeld setRect:feldrechteck];
			k = feldrechteck.origin.y + 8;
			//NSLog(@"k %d", k);
		}

		rechteck.size.height = k;//53;
	}
	if ([element boolAktion]) {
		rechteck.size.height += 23;
	}
	rechteck.origin.y = obenlinks - rechteck.size.height;
	[element setRect:rechteck];
	//NSLog(@"rechteck %f %f %f %f", rechteck.origin.x, rechteck.origin.y, rechteck.size.width, rechteck.size.height);

	
	//gelb
	[[NSColor colorWithDeviceRed:1 green:1 blue:0.46 alpha:1] set];
	[NSBezierPath fillRect:rechteck];
	
	//umrandung
	[self umrandung:element];
	
	//Titel setzen
	NSSize stringgroesse;
	stringgroesse = [[element titel] sizeWithAttributes:attrbg];
	//NSLog(@"textgroesse = %f %f", stringgroesse.width, stringgroesse.height);
	//Startpunkt fuer Text bestimmen
	p = rechteck.origin;
	p.y += rechteck.size.height - stringgroesse.height - 1;
	p.x += (rechteck.size.width - stringgroesse.width)/2;
	[[element titel] drawAtPoint:p withAttributes:attrbg];
	
	//Querstrich unter Titel
	strich = [[NSBezierPath alloc] init];
	[strich setLineWidth: 1.0];
	p.y = p.y - 2;
	p.x = rechteck.origin.x;
	[strich moveToPoint:p];
	p.x = p.x + rechteck.size.width;
	[strich lineToPoint:p];
	[strich stroke];
	
	//felder malen

	int j;
	for (j = 0; j < [eineFeldliste count]; j++) {
		einFeld = [eineFeldliste objectAtIndex:j];
		[self feldDesign:einFeld:element:NO];
	}
	//NSLog(@"rechteck.origin %f %f", rechteck.origin.x, rechteck.origin.y);
	//evtl. strich fuer dragged setzen unter das letzte feld
	if ([aktivesFeld dragged] && [element isEqualTo:vaterVonAktivemFeld]) {//und du der vater
		NSRect sensiblesFeld = rechteck;
		if ([element boolAktion]) {
			sensiblesFeld.origin.y += 23;
		}
		sensiblesFeld.size.height = 8;
	//	NSLog(@"strich setzen, altePos %f %f",altePos.x, altePos.y);
		NSPoint maus;
		maus = altePos;
		if ((sensiblesFeld.origin.x <= maus.x) && (maus.x <= sensiblesFeld.origin.x + sensiblesFeld.size.width) &&
			(sensiblesFeld.origin.y <= maus.y) && (maus.y <= sensiblesFeld.origin.y + sensiblesFeld.size.height)) {
			p.x = rechteck.origin.x + 10;
			p.y = sensiblesFeld.origin.y + 4;
			NSBezierPath* strich;
			strich = [[NSBezierPath alloc] init];
			[strich setLineWidth: 1.0];
			[[NSColor redColor] set];
			[strich moveToPoint:p];
			p.x += 90;
			[strich lineToPoint:p];
			[strich closePath];
			[strich stroke];
			positionFeld = [eineFeldliste count];
			//NSLog(@"position %d", positionFeld);
		}
	}
	
	//aktion zeichnen
	if ([element boolAktion]) {
		rechteck.origin.x += 112;
		rechteck.origin.y += 3;
		if ([element aktionGetroffen]) {
			[self aktionDesign:rechteck fuerMaus:NO aktionGetroffen:YES];
		}
		else {
			[self aktionDesign:rechteck fuerMaus:NO aktionGetroffen:NO];
		}
	}
	
}

-(void)menuDesign:(Menu*)element
{
	NSRect rechteck;
	NSPoint p;
	
	//position und groesse des Menus
	rechteck = [element rect];
	if ([element gemalt] == NO) {
		NSRect view = [self bounds];
		rechteck.origin.x = view.size.width / 2;
		rechteck.origin.y = view.size.height / 2;
		[element setRect:rechteck];
		[element setGemalt:YES];
	}
	//blau
	[[NSColor colorWithDeviceRed:0.34 green:0.73 blue:0.87 alpha:1] set];
	[NSBezierPath fillRect:rechteck];
	
	//umrandung
	[self umrandung:element];
	
	//Titel setzen
	NSSize stringgroesse;
	stringgroesse = [[element titel] sizeWithAttributes:attrbg];
	//Startpunkt fuer Text bestimmen
	p = rechteck.origin;
	p.y += (rechteck.size.height - stringgroesse.height)/2;
	p.x += (rechteck.size.width - stringgroesse.width)/2;
	[[element titel] drawAtPoint:p withAttributes:attrbg];
	
}

-(void)feldDesign:(id)element:(Formular*)vater:(BOOL)fuerMaus
{
	NSRect formRect = [vater rect];
	//NSLog(@"vaterRect %f %f", formRect.origin.x, formRect.origin.y);
	NSRect rechteck;
	NSPoint p = NSMakePoint(0,0);
	rechteck = [element rect];
	
	NSAffineTransform* xform = [NSAffineTransform transform];
	[xform translateXBy:formRect.origin.x yBy:formRect.origin.y];
	
	if (fuerMaus == NO) {
		[xform concat];
		
		float hoehe = rechteck.origin.y;
		//NSLog(@"hoehe %f", hoehe);
		rechteck.origin.y = formRect.size.height - hoehe;
		//NSLog(@"y vom feld %f",rechteck.origin.y);
		[element setRect:rechteck];
		if ([[element typ] isEqualToString:@"Feld"]) {
			//gruen
			[[NSColor colorWithDeviceRed:0.66 green:0.79 blue:0.28 alpha:1] set];
		}
		else {
			//grau
			[[NSColor colorWithDeviceRed:0.8 green:0.8 blue:0.8 alpha:1] set];
		}
		
	}
	else {
		p.x = altePos.x;
		p.y = altePos.y - rechteck.size.height / 2 - 25;
		rechteck.origin = p;
		[[NSColor colorWithDeviceRed:0.66 green:0.79 blue:0.28 alpha:0.3] set];
	}
	
	[NSBezierPath fillRect:rechteck];
	
	//umrandung
	
	NSBezierPath* umrandung;
	umrandung = [[NSBezierPath alloc] init];
	if (fuerMaus == NO) {
		if([element aktiv]){
			[umrandung setLineWidth: 2.0];
			[[NSColor colorWithDeviceRed:0 green:0 blue:0 alpha:1] set];
		} else {
			[umrandung setLineWidth: 1.0];
			[[NSColor colorWithDeviceRed:0.2 green:0.2 blue:0.2 alpha:1] set];
		}
	} else {
		[umrandung setLineWidth: 1.0];
		[[NSColor colorWithDeviceRed:0.2 green:0.2 blue:0.2 alpha:0.3] set];
	}

	p = rechteck.origin;
	[umrandung moveToPoint:p];
	p.x = p.x + rechteck.size.width; 
	[umrandung lineToPoint:p];
	p.y = p.y + rechteck.size.height;
	[umrandung lineToPoint:p];
	p.x = p.x - rechteck.size.width; 
	[umrandung lineToPoint:p];
	p.y = p.y - rechteck.size.height;
	[umrandung lineToPoint:p];
	[umrandung closePath];
	
	//mit stroke linie wird gefuellt, fill wuerde umschlossene flaeche fuellen
	[umrandung stroke];
	
	//Titel setzen
	//NSSize stringgroesse;
	//stringgroesse = [[element titel] sizeWithAttributes:attrbk];
	//Startpunkt fuer Text bestimmen
	p = rechteck.origin;
	p.y += rechteck.size.height - 16;
	p.x += 5;//linksbuendig
	//NSLog(@"feldrect %f %f", rechteck.origin.x, rechteck.origin.y);
	if (fuerMaus == YES) {
		if ([[element typ] isEqualToString:@"Feld"]) {
			[[element titel] drawAtPoint:p withAttributes:attrd];
			
			if ([element boolAktion]) {
				NSRect neuesRect = rechteck;
				neuesRect.origin.x += 92;
				neuesRect.origin.y += 3;
				//NSLog(@"%f %f", rechteck.origin.x, rechteck.origin.y);
				//NSLog(@"%f %f", neuesRect.origin.x, neuesRect.origin.y);
				[self aktionDesign:neuesRect fuerMaus:YES aktionGetroffen:NO];
			}
		}
		else {
			[[element typ] drawAtPoint:p withAttributes:attrd];
		}
	}
	else {
		if ([[element typ] isEqualToString:@"Feld"]) {
			[[element titel] drawAtPoint:p withAttributes:attrbk];
			
			if ([element boolAktion]) {
				NSRect neuesRect = rechteck;
				neuesRect.origin.x += 92;
				neuesRect.origin.y += 3;
				//NSLog(@"%f %f", rechteck.origin.x, rechteck.origin.y);
				//NSLog(@"%f %f", neuesRect.origin.x, neuesRect.origin.y);
				if ([element aktionGetroffen]) {
					[self aktionDesign:neuesRect fuerMaus:NO aktionGetroffen:YES];
				}
				else {
					[self aktionDesign:neuesRect fuerMaus:NO aktionGetroffen:NO];
				}
				
			}
			
		}
		else {
			[[element typ] drawAtPoint:p withAttributes:attrk];
		}
	//evtl. strich fuer dragged setzen nur fuer den vater
	if ([aktivesFeld dragged] && [vater isEqualTo:vaterVonAktivemFeld]) {
		NSRect sensiblesFeld = NSMakeRect(10,0,90,8);
		sensiblesFeld.origin.y = rechteck.origin.y + rechteck.size.height;
		//NSLog(@"strich setzen, altePos %f %f",altePos.x, altePos.y);
		NSPoint maus;
		maus = altePos;
		maus.x -= formRect.origin.x;
		maus.y -= formRect.origin.y;
		if ((sensiblesFeld.origin.x <= maus.x) && (maus.x <= sensiblesFeld.origin.x + sensiblesFeld.size.width) &&
			(sensiblesFeld.origin.y <= maus.y) && (maus.y <= sensiblesFeld.origin.y + sensiblesFeld.size.height)) {
			p.x = 10;
			p.y = sensiblesFeld.origin.y + 4;
			NSBezierPath* strich;
			strich = [[NSBezierPath alloc] init];
			[strich setLineWidth: 0.8];
			[[NSColor redColor] set];
			[strich moveToPoint:p];
			p.x = 100;
			[strich lineToPoint:p];
			[strich closePath];
			[strich stroke];
			positionFeld = [[vaterVonAktivemFeld feldliste] indexOfObject:element];
			//NSLog(@"position %d", positionFeld);
		}
	}
	
	
	[xform invert];
	[xform concat];
	}
}

-(void)aktionDesign:(NSRect)rechteck fuerMaus:(BOOL)maus aktionGetroffen:(BOOL)aG
{
	//NSLog(@"rechteck.origin %f %f", rechteck.origin.x, rechteck.origin.y);
	NSPoint p;
	NSBezierPath* aktionsfeld;
	aktionsfeld = [[NSBezierPath alloc] init];
	p = rechteck.origin;
	//p.x += 112;
	//p.y += 3;
	if (aG) {
		[aktionsfeld setLineWidth:2.0];
	}
	else {
		[aktionsfeld setLineWidth:1.0];
	}
	
	
	[aktionsfeld moveToPoint:p];
	p.y += 18;
	[aktionsfeld lineToPoint:p];
	p.x -= 45;
	[aktionsfeld lineToPoint:p];
	p.y -= 18;
	[aktionsfeld lineToPoint:p];
	p.x += 45;
	[aktionsfeld lineToPoint:p];
	[aktionsfeld closePath];
	
	//aktion schreiben
	NSString* titel = @"Aktion";
	p.x -= 38;
	p.y += 2;
	
	if (maus) {
		[[NSColor colorWithDeviceRed:0.92 green:0.63 blue:0 alpha:0.3] set];
		[aktionsfeld fill];
		[[NSColor colorWithDeviceRed:0.2 green:0.2 blue:0.2 alpha:0.3] set];
		[aktionsfeld stroke];
		[titel drawAtPoint:p withAttributes:attrd];
	}
	else {
		[[NSColor colorWithDeviceRed:0.92 green:0.63 blue:0 alpha:1] set];
		[aktionsfeld fill];
			if (aG) {
				[[NSColor colorWithDeviceRed:0 green:0 blue:0 alpha:1] set];
			}
			else {
				[[NSColor colorWithDeviceRed:0.2 green:0.2 blue:0.2 alpha:1] set];
			}
		[aktionsfeld stroke];
		[titel drawAtPoint:p withAttributes:attrk];
	}
}

-(void)umrandung:(id)element
{
	NSRect rechteck = [element rect];
	NSPoint p;
	NSBezierPath* umrandung;
	
	umrandung = [[NSBezierPath alloc] init];
	if ([element aktiv]) {
		[umrandung setLineWidth: 2.0];
		[[NSColor colorWithDeviceRed:0 green:0 blue:0 alpha:1] set];
	}
	else {
		[umrandung setLineWidth: 1.0];
		[[NSColor colorWithDeviceRed:0.2 green:0.2 blue:0.2 alpha:1] set];
	}
	
	p = NSMakePoint(rechteck.origin.x,rechteck.origin.y);
	[umrandung moveToPoint:p];
	p.x = p.x + rechteck.size.width; 
	[umrandung lineToPoint:p];
	p.y = p.y + rechteck.size.height;
	[umrandung lineToPoint:p];
	p.x = p.x - rechteck.size.width; 
	[umrandung lineToPoint:p];
	p.y = p.y - rechteck.size.height;
	[umrandung lineToPoint:p];
	[umrandung closePath];
	
	//mit stroke linie wird gefuellt, fill wuerde umschlossene flaeche fuellen
	[umrandung stroke];
}

-(void)uebergangDesign:(Uebergang*)uebergang
{
	//NSLog(@"uebergangDesign");
	id vater = [uebergang vater];
	NSRect vaterRect = [vater rect];
	//NSLog(@"feldrect %f %f", vaterRect.origin.x, vaterRect.origin.y);
	NSPoint startposition = vaterRect.origin;
	NSBezierPath* kante = [[NSBezierPath alloc] init];

	int startpunkt = [uebergang startpunkt];
	NSRect zielRect = [[uebergang ziel] rect];
	NSPoint zielposition = zielRect.origin;
	int zielpunkt = [uebergang zielpunkt];
	
	if (([[vater typ] isEqualToString:@"Feld"]) ||
		([[vater typ] isEqualToString:@"Block"])) {
		NSRect vaterVater = [[vater vater] rect];
		startposition.x += vaterVater.origin.x; 
		startposition.y += vaterVater.origin.y; 
	}
	
	switch (startpunkt) {
		case 1:
			startposition.y += vaterRect.size.height;
			break;
			
		case 2:
			startposition.x += vaterRect.size.width / 2;
			startposition.y += vaterRect.size.height;
			break;
			
		case 3:
			startposition.x += vaterRect.size.width;
			startposition.y += vaterRect.size.height;
			break;
			
		case 4:
			startposition.y += vaterRect.size.height / 2;
			break;
			
		case 5:
			startposition.x += vaterRect.size.width;
			startposition.y += vaterRect.size.height / 2;
			break;
			
		case 7:
			startposition.x += vaterRect.size.width / 2;
			break;
					
		case 8:
			startposition.x += vaterRect.size.width;
			break;
		default:
			break;
	}
	switch (zielpunkt) {
		case 1:
			zielposition.y += zielRect.size.height;
			break;
			
		case 2:
			zielposition.x += zielRect.size.width / 2;
			zielposition.y += zielRect.size.height;
			break;
			
		case 3:
			zielposition.x += zielRect.size.width;
			zielposition.y += zielRect.size.height;
			break;
			
		case 4:
			zielposition.y += zielRect.size.height / 2;
			break;
			
		case 5:
			zielposition.x += zielRect.size.width;
			zielposition.y += zielRect.size.height / 2;
			break;
			
		case 7:
			zielposition.x += zielRect.size.width / 2;
			break;
					
		case 8:
			zielposition.x += zielRect.size.width;
			break;
		default:
			break;
	}
	
	[kante setLineWidth:1.0];
	[kante moveToPoint:startposition];
	[kante lineToPoint:zielposition];
	[[NSColor blackColor] set];
	[kante stroke];
	
	// --- beschreibung an den pfeil setzen
	
	NSSize stringgroesse = [[uebergang bedingung] sizeWithAttributes:attrk];
	NSPoint beschreibungsPunkt; // an diese stelle soll die beschreibung gesetzt werden
	
	beschreibungsPunkt = startposition;
	
	// beschreibung am beschreibungspunkt zentrieren
	beschreibungsPunkt.x -= stringgroesse.width/2;
	beschreibungsPunkt.y -= stringgroesse.height/2;
	
	// beschreibungspunkt zur pfeilmitte ruecken
	beschreibungsPunkt.x += (zielposition.x - startposition.x)/2;
	beschreibungsPunkt.y += (zielposition.y - startposition.y)/2;
	
	NSRect beschreibungsRect; // Dort liegt das rechteck, dass die beschreibung umfasst
	
	// rectgroesse definieren
	beschreibungsRect.size.width = stringgroesse.width + 6;
	beschreibungsRect.size.height = stringgroesse.height + 2;
	
	// rect zur pfeilmitte ruecken
	beschreibungsRect.origin.x = startposition.x + (zielposition.x - startposition.x)/2 - (beschreibungsRect.size.width)/2;
	beschreibungsRect.origin.y = startposition.y + (zielposition.y - startposition.y)/2 - (beschreibungsRect.size.height)/2;
	
	// das rect weiss fuellen
	[[NSColor whiteColor] set];
	[NSBezierPath fillRect:beschreibungsRect];
	
	// das rect schwarz umranden
	[[NSColor blackColor] set];
	[NSBezierPath strokeRect:beschreibungsRect];
	
	// beschreibungstext zeichnen
	[[uebergang bedingung] drawAtPoint:beschreibungsPunkt withAttributes:attrk];
	
	// --- beschreibung ende
		
		
	
	NSRect anfasser = NSMakeRect(startposition.x - 4,startposition.y - 4,8,8);
	[[NSColor colorWithDeviceRed:0.8 green:0.8 blue:0.8 alpha:1] set];
	[NSBezierPath fillRect:anfasser];
	Anfasser* neu = [[Anfasser alloc] init];
	[neu setAnfRect:NSMakePoint(anfasser.origin.x - 1,anfasser.origin.y - 1)];
	[neu setVater:vater];
	[neu setUebergang:uebergang];
	[anfasserListe addObject:neu];
	[neu release];
	//NSLog(@"neues anfasserobjekt %f %f", [neu anfRect].origin.x, [neu anfRect].origin.y);
	anfasser.origin.x = zielposition.x - 4;
	anfasser.origin.y = zielposition.y - 4;
	[NSBezierPath fillRect:anfasser];
	Anfasser* neu2 = [[Anfasser alloc] init];
	[neu2 setAnfRect:NSMakePoint(anfasser.origin.x - 1,anfasser.origin.y - 1)];
	[neu2 setVater:[uebergang ziel]];
	[neu2 setUebergang:uebergang];
	[anfasserListe addObject:neu2];
	[neu2 release];
	//NSLog(@"neues anfasserobjekt %f %f", [neu2 anfRect].origin.x, [neu2 anfRect].origin.y);
	/*NSMutableArray* anfasserListe = [uebergang anfasserListe];
	if ([anfasserListe count] != 0) {
		int k;
		NSPoint anfasserPos;
		for (k = 0; k < [anfasserListe count]; k++) {
			anfasserPos = [anfasserListe objectAtIndex:k];
			anfasser.origin.x = anfasserPos.x - 3;
			anfasser.origin.y = anfasserPos.y - 3;
			[NSBezierPath fillRect:anfasser];
		}
	}*/
	
	//Pfeilspitze
	[self zeichnePfeilVon:startposition nach:zielposition];
	
}


-(void)zeichnePfeilVon:(NSPoint)a nach:(NSPoint)b
{
//[NSBezierPath strokeLineFromPoint:a toPoint:b];
[[NSColor blackColor] set];
NSBezierPath* pfeilspitze = [NSBezierPath bezierPath];
[pfeilspitze moveToPoint:NSMakePoint( 0.0, 0.0)];
[pfeilspitze lineToPoint:NSMakePoint( 0.0,-3.0)];
[pfeilspitze lineToPoint:NSMakePoint( 7.0, 0.0)];
[pfeilspitze lineToPoint:NSMakePoint( 0.0, 3.0)];
[pfeilspitze closePath];



NSAffineTransform* pfeilTransformation = [NSAffineTransform transform];
//[pfeilTransformation translateXBy:20 yBy:30];


float laenge = sqrt((b.x-a.x)*(b.x-a.x)+(b.y-a.y)*(b.y-a.y));


[pfeilTransformation translateXBy:a.x yBy:a.y];

if(b.x==a.x)
{
 if(b.y > a.y)
  [pfeilTransformation rotateByRadians:0.5*M_PI];
 else
  [pfeilTransformation rotateByRadians:1.5*M_PI];
}
else
{
 if(b.x > a.x)
 {
  if(b.y > a.y)
   [pfeilTransformation rotateByRadians:atan((b.y-a.y)/(b.x-a.x))];
  else
   [pfeilTransformation rotateByRadians:2*M_PI-atan(-(b.y-a.y)/(b.x-a.x))];
 }
 else
 {
  if(b.y > a.y)
   [pfeilTransformation rotateByRadians:M_PI-atan(-(b.y-a.y)/(b.x-a.x))];
  else
   [pfeilTransformation rotateByRadians:M_PI+atan((b.y-a.y)/(b.x-a.x))];
 }
}

[pfeilTransformation translateXBy:laenge-7 yBy:0.0];

[NSGraphicsContext saveGraphicsState];
 [pfeilTransformation concat];
 [pfeilspitze fill];
[[NSGraphicsContext currentContext] restoreGraphicsState];
}


-(NSMutableArray*)aktiveElemente
{
	return aktiveElemente;
}

-(void)setAktivesFeld:(MElement*)element
{
	aktivesFeld = element;
}

-(void)setGetroffenesElement:(MElement*)element
{
	getroffenesElement = element;
}

-(id)getroffenesElement
{
	return getroffenesElement;
}
-(BOOL)feldGetroffen {
	return feldGetroffen;
}
@end
