/* MyDocument */

#import <Cocoa/Cocoa.h>
#import "ApplicationController.h"
#import "Automat.h"
#import "Formular.h"
#import "Block.h"
#import "Feld.h"
#import "ModelView.h"
#import "Prompt.h"
#import "Filled.h"
#import "Option.h"
#import "Choice.h"
#import "Memo.h"
#import "Goto.h"
#import "Variable.h"
#import "Entscheidung.h"
#import "Clear.h"

@interface MyDocument : NSDocument
{
    IBOutlet id ausfuehrungDraw;
    IBOutlet id codeView;
    IBOutlet id dialogView;
    IBOutlet id modelfehlerView;
    IBOutlet id modelView;
    IBOutlet id syntaxfehlerView;
    IBOutlet id sprachCheck;
	IBOutlet id hilfePanel;
	IBOutlet id view1;
	IBOutlet id startStopButton;
	ApplicationController* applicationController;
	//um sie auf inaktiv zu setzen
	NSToolbarItem* validierung;
	
	//Liste mit Elementen, aus denen der Automat besteht
	Automat* automat;
	NSMutableArray* eListe;
	Automat* aktiverAutomat;
	
	//fuer das laden
	NSString* code;
	
	//fuer das parsen
	NSString* fehler;
	NSString* aktiverTag;
	MElement* aktiverZustand;
	MElement* aktivesFormitem;
	Prompt* aktiverPrompt;
	Filled* aktiverFilled;
	Option* aktiveOption;
	Choice* aktiveChoice;
	Entscheidung* aktiveEntscheidung;
	NSMutableArray* variablennamen;
	
	//fuer die ausfuehrung
	NSSpeechSynthesizer* synthesizer;
	NSSpeechRecognizer* recog;
	NSMutableArray* commands;
	NSMutableDictionary* systemText;
	NSMutableDictionary* benutzerText;
	NSTimer *timer;
	NSString* variablenDurchWerteErsetzt;
	BOOL fehlerPassiert;
	BOOL justSpeaking;
	//BOOL starteDialog;
	//BOOL dialogBeendet;
	BOOL dialogLaeuft;
	BOOL testMitSprache;
	BOOL eingabeWirdErwartet;
	NSMutableAttributedString* protokoll;
}
//Methoden der Toolbar
-(void)zustandLoeschen;
-(void)parse;
-(void)ausfuehrvorbereitung;
-(void)oeffneHilfePanel;
-(void)codeVorlage;
-(void)neuesFormular;
-(void)neuesMenu;
-(void)neuesFeld;
-(void)neuerBlock;
-(void)neueAktion;
-(void)neuerUebergang;

//fuer das parsen
-(BOOL)istZahl:(NSString*)string mitPunkt:(BOOL)b;
-(BOOL)istDtmf:(NSString*)string;
-(BOOL)istErstesZeichenRaute:(NSString*)string;

//Methoden fuer die ModelView
-(void)oeffneModellPanel:(id)element:(BOOL)dk aktion:(BOOL)ak;
-(void)setzeMehrfachPanel;

//Methoden vom ausfuehrungsDraw
- (IBAction)dtmf0:(id)sender;
- (IBAction)dtmf1:(id)sender;
- (IBAction)dtmf2:(id)sender;
- (IBAction)dtmf3:(id)sender;
- (IBAction)dtmf4:(id)sender;
- (IBAction)dtmf5:(id)sender;
- (IBAction)dtmf6:(id)sender;
- (IBAction)dtmf7:(id)sender;
- (IBAction)dtmf8:(id)sender;
- (IBAction)dtmf9:(id)sender;
- (IBAction)dtmfAsterisk:(id)sender;
- (IBAction)dtmfDiamond:(id)sender;
- (IBAction)ohneSprache:(id)sender;

//AUSFUEHRUNG
- (IBAction)starteDialog:(id)sender;
-(id)fuehreZustandAus:(MElement*)zustand;
-(void)fuehreFeldMenueAus:(MElement*)zustand;
-(void)saveInput:(NSString*)userInput;
-(void)fuehreAktionBlockAus:(MElement*)zustand;
-(NSMutableAttributedString*)setzePrompts:(NSMutableArray*)promptArray;


-(Variable*)gibVariableMitName:(NSString*)variablenname mitPunkt:(BOOL)punkt;
-(MElement*)gibFormularMitTitel:(NSString*)name;


-(NSString*)setzeAusdruck:(NSString*)wert;
-(void)setzeVariable:(Variable*)var;
-(NSString*)istStringVeraenderung:(NSString*)wert;
-(BOOL)istBerechnung:(NSString*)expr;
-(NSString*)berechneWertVonAusdruck:(NSString*)ausdruck;
-(BOOL)werteBedingungAus:(NSString*)bedingung;
-(NSString*)ersetzeVariablenInAusdruck:(NSString*)ausdruck;
@end
