#import "MyDocument.h"


@implementation MyDocument

- (id)init
{
    if (self = [super init]) {
		applicationController = [ApplicationController defaultApplicationController];
		automat = [[Automat alloc] init];
		aktiverAutomat = [[Automat alloc] init];
		[aktiverAutomat setzeDokument:self];
		synthesizer = [[NSSpeechSynthesizer alloc] init];
		[synthesizer setDelegate:self];
		recog = [[NSSpeechRecognizer alloc] init];
		[recog setDelegate:self];
		commands = [[NSMutableArray alloc] init];
		systemText = [[NSMutableDictionary alloc] init];
		benutzerText = [[NSMutableDictionary alloc] init];
		[systemText setObject:[NSColor brownColor]
								forKey:NSForegroundColorAttributeName];
		[benutzerText setObject:[NSColor blueColor]
								forKey:NSForegroundColorAttributeName];
		variablennamen = [[NSMutableArray alloc] init];
		//starteDialog = YES;
		dialogLaeuft = NO;
		testMitSprache = YES;
		justSpeaking = NO;
		code = [@"<vxml>\n\n//Fuege hier die Formulare und die Menues ein.\n\n</vxml>" retain];
		
    }
    return self;
}


// wird beim laden anstelle von init aufgerufen
- (id)initWithContentsOfURL:(NSURL *)absoluteURL ofType:(NSString *)typeName error:(NSError **)outError
{

    if (self = [super init]) {
		
		[self setFileURL:absoluteURL];
		[self setFileType:typeName];
		NSKeyedUnarchiver* unarchiver = [[NSKeyedUnarchiver alloc] initForReadingWithData:[NSData dataWithContentsOfURL:absoluteURL]];
		
		code = [[unarchiver decodeObjectForKey:@"inES code"] retain]; 
		
		applicationController = [ApplicationController defaultApplicationController];
		//automat = [[Automat alloc] init];
		automat = [[unarchiver decodeObjectForKey:@"inES Automat"] retain];
		
		aktiverAutomat = [[Automat alloc] init];
		[aktiverAutomat setzeDokument:self];
		synthesizer = [[NSSpeechSynthesizer alloc] init];
		[synthesizer setDelegate:self];
		recog = [[NSSpeechRecognizer alloc] init];
		[recog setDelegate:self];
		commands = [[NSMutableArray alloc] init];
		systemText = [[NSMutableDictionary alloc] init];
		benutzerText = [[NSMutableDictionary alloc] init];
		[systemText setObject:[NSColor brownColor]
								forKey:NSForegroundColorAttributeName];
		[benutzerText setObject:[NSColor blueColor]
								forKey:NSForegroundColorAttributeName];
		variablennamen = [[NSMutableArray alloc] init];
		
		[unarchiver finishDecoding];
		[unarchiver release];
		//starteDialog = YES;
		dialogLaeuft = NO;
		testMitSprache = YES;
		justSpeaking = NO;
		//protokoll = [[NSMutableAttributedString alloc] initWithString:@""];
    }
    return self;	
}

#pragma mark Toolbar Methoden
- (NSArray *)toolbarAllowedItemIdentifiers:(NSToolbar *)toolbar
{
	return [NSArray arrayWithObjects:
		NSToolbarShowColorsItemIdentifier, 
		NSToolbarShowFontsItemIdentifier, 
		NSToolbarPrintItemIdentifier,
		@"validiereCode",
		nil
	];
}

- (NSArray *)toolbarDefaultItemIdentifiers:(NSToolbar *)toolbar
{
	return [NSArray arrayWithObjects:
		//NSToolbarShowColorsItemIdentifier, 
		//NSToolbarShowFontsItemIdentifier, 
		//NSToolbarPrintItemIdentifier,
		NSToolbarCustomizeToolbarItemIdentifier,
		@"Validierung",
		@"Ausfuehrung",
		@"VoiceXML",
		@"codeVorlage",
		@"formular",
		@"menu",
		@"feld",
		@"block",
		@"aktion",
		@"uebergang",
		@"loeschen",
		nil
	];
}

- (NSArray *)toolbarSelectableItemIdentifiers:(NSToolbar *)toolbar
{
	return nil;
}

- (NSToolbarItem *)toolbar:(NSToolbar *)toolbar 
		itemForItemIdentifier:(NSString *)itemIdentifier 
		willBeInsertedIntoToolbar:(BOOL)flag
{
	 NSToolbarItem* item = [[[NSToolbarItem alloc] initWithItemIdentifier:itemIdentifier] autorelease];
	 if ([itemIdentifier isEqual:@"Validierung"])
	 {
		validierung = item;
		[validierung setLabel:@"Syntax testen"];
		[validierung setImage:[NSImage imageNamed:@"battn.tiff"]];
		[validierung setTarget:self];
		[validierung setAction:@selector(parse)];
		[validierung setEnabled:YES];
	
		return item;
	} 
	else if ([itemIdentifier isEqual:@"Ausfuehrung"])
	{
		[item setLabel:@"Dialog starten"];
		[item setImage:[NSImage imageNamed:@"battn.tiff"]];
		[item setTarget:self];
		[item setAction:@selector(ausfuehrvorbereitung)];
		[item setEnabled:YES];

		return item;
	}
	else if ([itemIdentifier isEqual:@"VoiceXML"])
	{
		[item setLabel:@"Hilfe VoiceXML"];
		[item setImage:[NSImage imageNamed:@"battn.tiff"]];
		[item setTarget:self];
		[item setAction:@selector(oeffneHilfePanel)];
		[item setEnabled:YES];

		return item;
	}
	else if ([itemIdentifier isEqual:@"codeVorlage"])
	{
		[item setLabel:@"Code-Vorlage"];
		[item setImage:[NSImage imageNamed:@"battn.tiff"]];
		[item setTarget:self];
		[item setAction:@selector(codeVorlage)];
		[item setEnabled:YES];

		return item;
	}
	else if ([itemIdentifier isEqual:@"formular"])
	{
		[item setLabel:@"Formular"];
		[item setImage:[NSImage imageNamed:@"Formular_32.tif"]];
		[item setTarget:self];
		[item setAction:@selector(neuesFormular)];
		[item setEnabled:YES];

		return item;
	}
	else if ([itemIdentifier isEqual:@"menu"])
	{
		[item setLabel:@"Menue"];
		[item setImage:[NSImage imageNamed:@"Menue_32.tif"]];
		[item setTarget:self];
		[item setAction:@selector(neuesMenu)];
		[item setEnabled:YES];

		return item;
	}
	else if ([itemIdentifier isEqual:@"feld"])
	{
		[item setLabel:@"Feld"];
		[item setImage:[NSImage imageNamed:@"Feld_32.tif"]];
		[item setTarget:self];
		[item setAction:@selector(neuesFeld)];
		[item setEnabled:YES];

		return item;
	}
	else if ([itemIdentifier isEqual:@"block"])
	{
		[item setLabel:@"Block"];
		[item setImage:[NSImage imageNamed:@"Block_32.tif"]];
		[item setTarget:self];
		[item setAction:@selector(neuerBlock)];
		[item setEnabled:YES];

		return item;
	}
	else if ([itemIdentifier isEqual:@"aktion"])
	{
		[item setLabel:@"Aktion"];
		[item setImage:[NSImage imageNamed:@"Aktion_32.tif"]];
		[item setTarget:self];
		[item setAction:@selector(neueAktion)];
		[item setEnabled:YES];

		return item;
	}
	else if ([itemIdentifier isEqual:@"uebergang"])
	{
		[item setLabel:@"Uebergang"];
		[item setImage:[NSImage imageNamed:@"Uebergang_32.tif"]];
		[item setTarget:self];
		[item setAction:@selector(neuerUebergang)];
		[item setEnabled:YES];

		return item;
	}
	else if ([itemIdentifier isEqual:@"loeschen"])
	{
		[item setLabel:@"Loeschen"];
		[item setImage:[NSImage imageNamed:@"Loeschen_32.tif"]];
		[item setTarget:self];
		[item setAction:@selector(zustandLoeschen)];
		[item setEnabled:YES];

		return item;
	}
	else {
		item = nil;
		return nil;
	}
	
}

#pragma mark Funktionen der Toolbar

-(void)zustandLoeschen
{
	MElement* aktivesElement = [modelView gibAktivesElement];/*
	BOOL feldGetroffen = [modelView feldGetroffen];
	if (feldGetroffen == YES) {
		if ([aktivesElement boolAktion] == YES) {
			if ([aktivesElement aktionGetroffen] == YES) {
				[aktivesElement setBoolAktion:NO];
				[modelView setNeedsDisplay:YES];
				return;
			}
		}
	}*/
	MElement* getrElement = [modelView getroffenesElement];
	if ([getrElement boolAktion] == YES) {
		if ([getrElement aktionGetroffen] == YES) {
			[getrElement setBoolAktion:NO];
			[modelView setNeedsDisplay:YES];
			return;
		}
	}

	
	if(!aktivesElement) //	Kein Element oder mehrere Elemente ausgew√§hlt?
	{
		NSBeep(); //  Warnton ausgeben
		return; //	und nichts machen
	}
	
	//uebergaenge im aktiven Automaten loeschen
	int i,n;
	NSMutableArray* uebergangslisteAutomat = [automat uebergListe];
	n = [uebergangslisteAutomat count];
	
	Uebergang* uebergang;
	for (i=0; i<n; i++) {
		uebergang = [uebergangslisteAutomat objectAtIndex:i];
		if([uebergang vater] == aktivesElement) {
			[uebergangslisteAutomat removeObject:uebergang];
			i--;
			n--;
		}
	}
	
	
	MElement* vater;
	MElement* ziel;
	NSMutableArray* uebergangslisteVater;
	NSString* typ = [aktivesElement typ];
	
	if([typ isEqualToString:@"Formular"] || [typ isEqualToString:@"Menue"])
	{
		//	In diesem Fall koennen Uebergange auf das aktive Element zeigen.
		//	Diese werden nun entfernt.
		
		
		
		for(i=0;i<n;i++)
		{
			uebergang = [uebergangslisteAutomat objectAtIndex:i];
			if([uebergang ziel] == aktivesElement) //  Zeigt dieser Uebergang auf das zu loeschende Objekt?
			{
				//	Dann muss dessen Vater informiert werden.
				vater = [uebergang vater];
				uebergangslisteVater = [vater uebergangListe];
				[uebergangslisteVater removeObject:uebergang];
				if ([uebergangslisteVater count] == 0) {
					[vater setBoolUebergang:NO];
				}

				//	Wir loeschen den Uebergang aus der Liste
				[uebergangslisteAutomat removeObject:uebergang];
				
				i--;
				n--;
			}
		}
		
		//	Schliesslich wird das zu loeschende Element aus dem Automaten entfernt
	//NSLog(@"%d", [aktivesElement retainCount]);
		[[automat eListe] removeObject: aktivesElement];
	//NSLog(@"%d", [aktivesElement retainCount]);
		[[modelView aktiveElemente] removeObject:aktivesElement];
	}
	else
	{
		//	aktivesElement ist vom Typ Feld oder Block, ist also Kind eines Formulars
	//NSLog(@"%d", [aktivesElement retainCount]);
		[[[aktivesElement vater] feldliste] removeObject:aktivesElement];
		
		//[modelView resetAktiveElemente];
	}
	
	[modelView setAktivesFeld:nil];
	[modelView setGetroffenesElement:nil];
		
	//	Die ModelView neu zeichnen
	[modelView setNeedsDisplay:YES];
	
}

-(void)parse
{
	[aktiverAutomat cleanUp];
	aktiverTag = @"";
	//variablen = [aktiverAutomat variablen];
	NSData* quellcode = [[codeView string] dataUsingEncoding:NSASCIIStringEncoding allowLossyConversion:YES];
	NSXMLParser* xmlParser = [[NSXMLParser alloc] initWithData:quellcode];
	[xmlParser setDelegate:self];
	//[xmlParser setShouldResolveExternalEntities:YES];
	BOOL success;
	success = [xmlParser parse];
	BOOL success2 = NO;
	
	if (success) {
		Memo* memo = [aktiverAutomat memoCheck];
		
		if (memo) {

			NSString* fehlertext = [NSString stringWithFormat:@"Fehler gefunden:\nZeile: %i\nBeschreibung: %@ verweist auf das ungueltige Element %@", [memo lineNumber], 
			[memo befehl], [memo inhalt]];
			[syntaxfehlerView setString:fehlertext];
		}
		else {
			success2 = YES;
		}
	}

	if (success && success2) {
			[syntaxfehlerView setString:@"Keine Fehler gefunden."];
	}
	[xmlParser release];
	
}

-(void)ausfuehrvorbereitung
{

	[ausfuehrungDraw open];	
}

-(void)oeffneHilfePanel
{	
	Block* element = [[Block alloc] init];
	[applicationController showHilfePanel:element];
}

-(void)codeVorlage
{
	id element = [modelView gibAktivesElement];
	if (element) {
		NSString* code = [(MElement*)element code];
		[codeView insertText:code];

	}
	
}

-(void)neuesFormular
{
	Formular* formular = [[Formular alloc] init];

	[formular setzeDokument:self];
	[formular setzeView:modelView];
	[formular setAutomat:automat];
	eListe = [automat eListe];
	[eListe addObject:formular];
	[formular release];

	[modelView neuesElement:formular];

}

-(void)neuesMenu
{
	Menu* menu = [[Menu alloc] init];
	[menu setzeView:modelView];
	[menu setAutomat:automat];
	eListe = [automat eListe];
	[eListe addObject:menu];
	[modelView neuesElement:menu];
	[menu release];
}

-(void)neuesFeld
{
	BOOL erlaubt = [modelView neuesFormitemErlaubt];
	if (erlaubt) {

		id vater = [modelView vaterVonAktivemFeld];
		Feld* feld = [[Feld alloc] init];
		[feld setzeView:modelView];
		[feld setAutomat:automat];
		[feld setVater:vater];
		//dem Formular das Feld hinzufuegen
		[vater addFormitem:feld];

		[modelView neuesElement:feld];

		[feld release];
	}
	else {
	//NSLog(@"nicht erlaubt");
	}
}

-(void)neuerBlock
{
	BOOL erlaubt = [modelView neuesFormitemErlaubt];
	if (erlaubt) {

		id vater = [modelView vaterVonAktivemFeld];
		Block* block = [[Block alloc] init];
		[block setzeView:modelView];
		[block setAutomat:automat];
		[block setVater:vater];
		//dem Formular das Feld hinzufuegen
		[vater addFormitem:block];
		[modelView neuesElement:block];
		[block release];
	}
	else {
	//NSLog(@"nicht erlaubt");
	}
}

-(void)neueAktion
{
	BOOL erlaubt = [modelView neueAktionErlaubt];
	if (erlaubt) {

		[modelView setNeedsDisplay:YES];
		//id vater = [modelView vaterVonAktivemFeld];
		//[self oeffneModellPanel:vater :NO];
	}
	else {
	//NSLog(@"nicht erlaubt");
	}
}

-(void)neuerUebergang
{
	//kann ein neuer ueberg gesetzt werden?
	BOOL erlaubt = [modelView neuerUebergangErlaubt];
	if (erlaubt) {
		[[modelView window] makeFirstResponder:modelView];
		[[modelView window] setAcceptsMouseMovedEvents:YES];
		[modelView setUebergangSetzen:YES];
	}
	else {
	//NSLog(@"neuer Uebergang nicht erlaubt");
	}
	
	//[modelView setNeedsDisplay:YES];
}

#pragma mark Parse-Methoden

-(BOOL)istZahl:(NSString*)string mitPunkt:(BOOL)b
{
	int laenge = [string length];
	BOOL ok = YES;
	int k;
	const char* string2 = [string cStringUsingEncoding:NSASCIIStringEncoding];
	for (k=0; k< laenge; k++) {
		if(string2[k] <= '9' && string2[k] >= '0'){
		}
		else {
			if(b) {
				if (string2[k] == '.') {}
				else {
					ok = NO;
					break;
				}
			}
			else {
				ok = NO;
				break;
			}
		}
	}
	return ok;
}

-(BOOL)istDtmf:(NSString*)string
{
	int laenge = [string length];
	if (laenge != 1) {
		return NO;
	}
	const char* string2 = [string cStringUsingEncoding:NSASCIIStringEncoding];
	if(string2[0] <= '9' && string2[0] >= '0'){
		return YES;
	} 
	else if (string2[0] == '#' || string2[0] == '*') {
		return YES;
	}
	else {
		return NO;
	}
}

-(BOOL)istErstesZeichenRaute:(NSString*)string
{
	const char* string2 = [string cStringUsingEncoding:NSASCIIStringEncoding];
	if (string2[0] == '#') {
		return YES;
	}
	else {
		return NO;
	}
}


- (void)parser:(NSXMLParser *)xmlParser didStartElement:(NSString *)tag namespaceURI:(NSString *)namespaceURI qualifiedName:(NSString *)qName attributes:(NSDictionary *)attributeDict {
 
	if ([tag isEqualToString:@"vxml"]) {
		if ([aktiverTag isEqualToString:@""]) {
			aktiverTag = @"vxml";

		}
		return;
	}
    if ([tag isEqualToString:@"form"]) {
		if ([aktiverTag isEqualToString:@"vxml"]) {
			Formular* formular = [[Formular alloc] init];
			[formular setAutomat:aktiverAutomat];
			[[aktiverAutomat eListe] addObject:formular];
			aktiverZustand = formular;
			[formular release];
			
			NSString* titel = [attributeDict objectForKey:@"id"];
			if (titel){
				[formular setTitel:titel];
				[aktiverAutomat addName:titel von:@"zustand"];
			}
			aktiverTag = @"form";

		}
		else {
			fehler = @"Ein Formular muss innerhalb eines <vxml>-Befehls liegen.";
			[xmlParser abortParsing];
		}
		return;
    }
	if ([tag isEqualToString:@"menu"]) {
		if ([aktiverTag isEqualToString:@"vxml"]) {
			Menu* menue = [[Menu alloc] init];
			[menue setAutomat:aktiverAutomat];
			[[aktiverAutomat eListe] addObject:menue];
			aktiverZustand = menue;
			[menue release];
			NSString* titel = [attributeDict objectForKey:@"id"];
			if (titel){
				[menue setTitel:titel];
				[aktiverAutomat addName:titel von:@"zustand"];
			}
			aktiverTag = @"menu";
		}
		else {
			fehler = @"Ein Menue muss innerhalb eines <vxml>-Befehls liegen.";
			[xmlParser abortParsing];
		}
		return;
	}
	if ([tag isEqualToString:@"field"]) {
		if ([aktiverTag isEqualToString:@"form"]) {
			//Formular* vater = [self aktivesFormular];
			Feld* feld = [[Feld alloc] init];
			[feld setAutomat:aktiverAutomat];
			[feld setVater:aktiverZustand];
			//[feld setVorgaenger:aktiverTag];
			[(Formular*)aktiverZustand addFormitem:feld];
			[feld setVorgaenger:aktiverTag];
			aktivesFormitem = feld;
			[feld release];
			NSString* titel = [attributeDict objectForKey:@"name"];
			if (titel){
				[feld setTitel:titel];
				[aktiverAutomat addName:titel von:@"feld"];
				[variablennamen addObject:titel];
			}
			else {
				//fehler = @"Felder benoetigen das Attribut name.";
				//[xmlParser abortParsing];
			}
			NSString* type = [attributeDict objectForKey:@"type"];
			if (type){
				if ([type isEqualToString:@"boolean"] || [type isEqualToString:@"digits"] ||
					[type isEqualToString:@"number"] ||[type isEqualToString:@"date"]) {
					
					[feld setExprTyp:type];
				}
				else {
					fehler = [NSString stringWithFormat:@"Der Typ %@ wird nicht unterstuetzt.", type];
					[xmlParser abortParsing];
				}
			}
			aktiverTag = @"field";
		}
		else {
			fehler = @"Felder koennen nur innerhalb von Formularen liegen.";
			[xmlParser abortParsing];
		}
		return;
	}
	
	if ([tag isEqualToString:@"block"]) {
		if ([aktiverTag isEqualToString:@"form"]) {
			Block* block = [[Block alloc] init];
			[block setAutomat:aktiverAutomat];
			[block setVater:aktiverZustand];
			//[block setVorgaenger:aktiverTag];
			[(Formular*)aktiverZustand addFormitem:block];
			aktivesFormitem = block;
			[block release];
			aktiverTag = @"block";
		}
		else {
			fehler = @"Bloecke koennen nur innerhalb von Formularen liegen.";
			[xmlParser abortParsing];
		}
		return;
	}
	
	if ([tag isEqualToString:@"filled"]) {//1
		if ([aktiverTag isEqualToString:@"form"]){
			if (![aktiverZustand boolAktion]) {
				[aktiverZustand setBoolAktion:YES];
				aktiverFilled = [(Formular*)aktiverZustand filled];
				[aktiverFilled setVorgaenger:aktiverTag];
				aktiverTag = @"filled";
			}
			else {
				fehler = @"Formulare koennen nur eine Aktion (filled) besitzen.";
				[xmlParser abortParsing];
			}
		} else if ([aktiverTag isEqualToString:@"field"]) {
			if (![aktivesFormitem boolAktion]) {
				[aktivesFormitem setBoolAktion:YES];//feld noch ohne aktion
				aktiverFilled = [(Feld*)aktivesFormitem filled];
				[aktiverFilled setVorgaenger:aktiverTag];
				aktiverTag = @"filled";
			}
			else {
				fehler = @"Felder koennen nur eine Aktion (filled) besitzen.";
				[xmlParser abortParsing];
				//aktionsFehler = YES;
			}
		} else {
			fehler = @"Aktionen (filled) koennen nur innerhalb von Formularen oder Feldern stehen.";
			[xmlParser abortParsing];
		}
		return;
	}//1
	if ([tag isEqualToString:@"prompt"]) {
		if ([aktiverTag isEqualToString:@"field"] || [aktiverTag isEqualToString:@"block"] ||
			[aktiverTag isEqualToString:@"menu"] || [aktiverTag isEqualToString:@"filled"]  || [aktiverTag isEqualToString:@"if"]) {
			Prompt* prompt = [[Prompt alloc] init];
			//NSLog(@"%d", [prompt retainCount]);
			[prompt setVorgaenger:aktiverTag];
			if ([aktiverTag isEqualToString:@"field"]) {
				[(Feld*)aktivesFormitem addPrompt:prompt];
				
			}
			else if ([aktiverTag isEqualToString:@"block"]) {
				[(Block*)aktivesFormitem addAktionsbefehl:prompt];
			}
			else if([aktiverTag isEqualToString:@"menu"]) {
				[(Menu*)aktiverZustand addPrompt:prompt];
			} 
			else if([aktiverTag isEqualToString:@"filled"]) {
				[aktiverFilled addAktionsbefehl:prompt];
			}
			else {
				BOOL elseZweig = [aktiveEntscheidung elseZweig];
				if (elseZweig == YES) {
					[aktiveEntscheidung addElseBefehl:prompt];
				} 
				else {
					[aktiveEntscheidung addIfBefehl:prompt];
				}
			}
			[prompt release];
			NSString* count = [attributeDict objectForKey:@"count"];
			if (count){
				BOOL erlaubt = [self istZahl:count mitPunkt:NO];
				if (erlaubt) {
					int countInt = [count intValue];
					[prompt setDurchlauf:countInt];

				} else {
					fehler = @"Das Attribut count kann nur Zahlen enthalten.";
					[xmlParser abortParsing];
				}
			}
			NSString* bargein = [attributeDict objectForKey:@"bargein"];
			if (bargein) {
				if ([bargein isEqualToString:@"true"]) {
					[prompt setBargein:YES];
				}
				else if ([bargein isEqualToString:@"false"]) {
					[prompt setBargein:NO];
				}
				else {
					fehler = @"Das Attribut bargein kann nur auf true oder false gesetzt werden.";
					[xmlParser abortParsing];
				}
			}
			aktiverPrompt = prompt;
			aktiverTag = @"prompt";
		}
		else {
			fehler = @"Hier kann kein Prompt stehen.";
			[xmlParser abortParsing];
		}
	return;
	}
	
#pragma mark ------------------ value
	
	if ([tag isEqualToString:@"value"]) {
		if ([aktiverTag isEqualToString:@"prompt"]) {
			NSString* expr = [attributeDict objectForKey:@"expr"];
			if (expr){
				[aktiverPrompt setVarListe:expr];
				//Memo* memo = [[Memo alloc] init];
				//[memo setBefehl:tag];
				//[memo setInhalt:expr];
				//[memo setLineNumber:[xmlParser lineNumber]];
				//[aktiverAutomat addMemo:memo];
				//[memo release];
				//NSLog(@"memo %d", [memo retainCount]);
				//NSLog(@"value for expr %@", expr);
			} 
			else {
				fehler = @"<value/> benoetigt das Attribut expr.";
				[xmlParser abortParsing];
			}
		}
		else {
			fehler = @"Values koennen nur innerhalb von Prompts eingebunden werden.";
			[xmlParser abortParsing];
		}
	return;
	}
	if ([tag isEqualToString:@"enumerate"]) {
		if ([aktiverTag isEqualToString:@"prompt"]) {
			[aktiverPrompt setEnumerate:YES];
		}
		else {
			fehler = @"<enumerate/> kann nur in Prompts eingebunden werden.";
			[xmlParser abortParsing];
		}
	return;
	}
	
#pragma mark ------------------ choice und option
	
	if ([tag isEqualToString:@"option"]) {
		if ([aktiverTag isEqualToString:@"field"]) {
			Option* option = [[Option alloc] init];
			//NSLog(@"%d",[option retainCount]);
			[(Feld*)aktivesFormitem addOption:option];
			[option release];
			//NSLog(@"%d",[option retainCount]);
			NSString* dtmf = [attributeDict objectForKey:@"dtmf"];
			if (dtmf) {
				BOOL erlaubt = [self istDtmf:dtmf];
				if (erlaubt) {
					[option setDtmf:dtmf];
				}
				else {
					fehler = @"Das Attribut dtmf kann auf 0 bis 9, * oder # gesetzt werden.";
					[xmlParser abortParsing];
				}
			}
			NSString* value = [attributeDict objectForKey:@"value"];
			if (value) {
				[option setValue:value];
				[option setValueGesetzt:YES];
			}
			
			aktiveOption = option;
			//
			aktiverTag = @"option";
		}
		else {
			fehler = @"Optionen koennen nur in Felder eingebunden werden.";
			[xmlParser abortParsing];
		}
	return;
	}
	
	if ([tag isEqualToString:@"choice"]) {
		if ([aktiverTag isEqualToString:@"menu"]) {
			Choice* choice = [[Choice alloc] init];
			[(Menu*)aktiverZustand addChoice:choice];
			[choice release];
			NSString* dtmf = [attributeDict objectForKey:@"dtmf"];
			if (dtmf) {
				BOOL erlaubt = [self istDtmf:dtmf];
				if (erlaubt) {
					[choice setDtmf:dtmf];
				}
				else {
					fehler = @"Das Attribut dtmf kann auf 0 bis 9, * oder # gesetzt werden.";
					[xmlParser abortParsing];
				}
			}
			NSString* next = [attributeDict objectForKey:@"next"];
			if (next) {
				BOOL erlaubt = [self istErstesZeichenRaute:next];
				if (erlaubt) {
					[choice setNext:next];
					Memo* memo = [[Memo alloc] init];
					[memo setBefehl:tag];
					[memo setInhalt:[next substringFromIndex:1]];
					[memo setLineNumber:[xmlParser lineNumber]];
					[aktiverAutomat addMemo:memo];
					[memo release];
					//NSLog(@"memo %d", [memo retainCount]);
				}
				else {
					fehler = @"Der Wert des Attributes next muss mit # beginnen.";
					[xmlParser abortParsing];
				}
			} 
			else {
				fehler = @"Das Attribut next fehlt.";
				[xmlParser abortParsing];
			}
			aktiveChoice = choice;
			//
			aktiverTag = @"choice";
		}
		else {
			fehler = @"<choice> kann nur in Menues eingebunden werden.";
			[xmlParser abortParsing];
		}
	return;
	}
	
#pragma mark ------------------ goto
	
	if ([tag isEqualToString:@"goto"]) {
		if ([aktiverTag isEqualToString:@"block"] || [aktiverTag isEqualToString:@"filled"] || [aktiverTag isEqualToString:@"if"]) {
			Goto* neuerGoto = [[Goto alloc] init];
			if ([aktiverTag isEqualToString:@"block"]) {
				[(Block*)aktivesFormitem addAktionsbefehl:neuerGoto];
			}
			else if ([aktiverTag isEqualToString:@"filled"]){
				[aktiverFilled addAktionsbefehl:neuerGoto];
			}
			else {
				BOOL elseZweig = [aktiveEntscheidung elseZweig];
				if (elseZweig == YES) {
					[aktiveEntscheidung addElseBefehl:neuerGoto];
				} 
				else {
					[aktiveEntscheidung addIfBefehl:neuerGoto];
				}
			}
			[neuerGoto release];
			NSString* next = [attributeDict objectForKey:@"next"];
			if (next) {
				BOOL erlaubt = [self istErstesZeichenRaute:next];
				if (erlaubt) {
					[neuerGoto setNext:next];
					Memo* memo = [[Memo alloc] init];
					[memo setBefehl:tag];
					[memo setInhalt:[next substringFromIndex:1]];
					[memo setLineNumber:[xmlParser lineNumber]];
					[aktiverAutomat addMemo:memo];
					[memo release];
					//NSLog(@"memo %d", [memo retainCount]);
				}
				else {
					fehler = @"Der Wert des Attributes next muss mit # beginnen.";
					[xmlParser abortParsing];
				}
			} 
			else {
				fehler = @"Das Attribut next fehlt.";
				[xmlParser abortParsing];
			}
		}
		else {
			fehler = @"<goto> kann nur in Bloecke oder Aktionen eingebunden werden.";
			[xmlParser abortParsing];
		}
	return;
	}
	
#pragma mark ------------------ var
	
	if ([tag isEqualToString:@"var"]) {
		if ([aktiverTag isEqualToString:@"vxml"] || [aktiverTag isEqualToString:@"form"]||
			[aktiverTag isEqualToString:@"filled"] || [aktiverTag isEqualToString:@"block"] || [aktiverTag isEqualToString:@"if"]) {
			
			NSString* name = [attributeDict objectForKey:@"name"];
			if (name) {
				Variable* var = [[Variable alloc] init];
				[var setDefinition:YES];
				[var setName:name];
				
				[variablennamen addObject:name];
				NSString* expr = [attributeDict objectForKey:@"expr"];
				if (expr) {
					[var setExpr:expr];
				}

				if ([aktiverTag isEqualToString:@"vxml"]) {
					[aktiverAutomat addVariable:var];
				//NSLog(@"neue %@", [var description]);
					[var setOwner:@"vxml"];
				}
				else if([aktiverTag isEqualToString:@"form"]) {
					[(Formular*)aktiverZustand addVariable:var];
					[var setOwner:aktiverZustand];
				}
				else if([aktiverTag isEqualToString:@"filled"]) {
					[aktiverFilled addVariable:var];
					[var setOwner:aktiverFilled];
				}
				else if([aktiverTag isEqualToString:@"block"]) {
					[(Block*)aktivesFormitem addVariable:var];
					[var setOwner:aktivesFormitem];
				}
				else {
					BOOL elseZweig = [aktiveEntscheidung elseZweig];
					if (elseZweig == YES) {
						[aktiveEntscheidung addVariable:var inListe:@"else"];
						[var setOwner:aktiveEntscheidung];
					} 
					else {
						[aktiveEntscheidung addVariable:var inListe:@"if"];
						[var setOwner:aktiveEntscheidung];
					}
				}
				[var release];
			//NSLog(@"neue %@", [var description]);
			} else {
				fehler = @"Variablen benoetigen das Attribut name.";
				[xmlParser abortParsing];
			}
			
		} else {
			fehler = @"Variablen koennen hier nicht definiert werden.";
			[xmlParser abortParsing];
		}
	return;
	}
	
#pragma mark ------------------ assign
	
	if ([tag isEqualToString:@"assign"]) {
		if ([aktiverTag isEqualToString:@"filled"] || [aktiverTag isEqualToString:@"block"] || [aktiverTag isEqualToString:@"if"]) {
			BOOL drin = NO;
			NSString* name = [attributeDict objectForKey:@"name"];
			if (name) {
				NSString* expr = [attributeDict objectForKey:@"expr"];
				if (expr) {
					Variable* assign = [[Variable alloc] init];
					[assign setName:name];
					[assign setExpr:expr];
					if([aktiverTag isEqualToString:@"filled"]) {
						[aktiverFilled addAktionsbefehl:assign];
					}
					else if([aktiverTag isEqualToString:@"block"]) {
						[(Block*)aktivesFormitem addAktionsbefehl:assign];
					}
					else {
						BOOL elseZweig = [aktiveEntscheidung elseZweig];
						if (elseZweig == YES) {
							[aktiveEntscheidung addElseBefehl:assign];
						} 
						else {
							[aktiveEntscheidung addIfBefehl:assign];
						}
					}
					[assign release];
					drin = YES;
				//NSLog(@"ASSIGN %@", [assign description]);
				}
			}
			if (drin == NO) {
				fehler = @"Variablen benoetigen die Attribute name und expr.";
				[xmlParser abortParsing];
			}
			
		} else {
			fehler = @"<assign> kann nur in Bloecke oder Aktionen eingebunden werden.";
			[xmlParser abortParsing];
		}
	return;
	}
	
#pragma mark ------------------ if

	if ([tag isEqualToString:@"if"]) {
		if ([aktiverTag isEqualToString:@"filled"] || [aktiverTag isEqualToString:@"block"] || [aktiverTag isEqualToString:@"if"]) {
			Entscheidung* neueEntsch = [[Entscheidung alloc] init];
			if ([aktiverTag isEqualToString:@"filled"]) {
				[aktiverFilled addAktionsbefehl:neueEntsch];
				[neueEntsch setVorgaenger:aktiverFilled];
			}
			else if ([aktiverTag isEqualToString:@"block"]) {
				[(Block*)aktivesFormitem addAktionsbefehl:neueEntsch];
				[neueEntsch setVorgaenger:aktivesFormitem];
			}
			else if ([aktiverTag isEqualToString:@"if"]) {
				if ([aktiveEntscheidung elseZweig] == NO) {
					[aktiveEntscheidung addIfBefehl:neueEntsch];
				}
				else {
					[aktiveEntscheidung addElseBefehl:neueEntsch];
				}
				[neueEntsch setVorgaenger:aktiveEntscheidung];
			}
			[neueEntsch release];
			NSString* cond = [attributeDict objectForKey:@"cond"];
			if (cond) {
				[neueEntsch setBedingung:cond];
			}
			else {
				fehler = @"<if> benoetigt das Attribut cond, in der die Bedingung steht.";
				[xmlParser abortParsing];
			}
			aktiverTag = @"if";
			aktiveEntscheidung = neueEntsch;
		}
		else {
			fehler = @"<if> kann nur in Bloecke oder Aktionen eingebunden werden.";
			[xmlParser abortParsing];
		}
	return;
	}
	if ([tag isEqualToString:@"else"]) {
		if ([aktiverTag isEqualToString:@"if"]) {
			[aktiveEntscheidung setElseZweig:YES];
		}
		else {
			fehler = @"<else/> kann nur innerhalb von <if> stehen.";
			[xmlParser abortParsing];
		}
	return;
	}
	if ([tag isEqualToString:@"elseif"]) {
		if ([aktiverTag isEqualToString:@"if"]) {
			Entscheidung* neueEntsch = [[Entscheidung alloc] init];
			BOOL elseZweig = [aktiveEntscheidung elseZweig];
			if (elseZweig == NO) {
				[aktiveEntscheidung addElseBefehl:neueEntsch];
			}
			else {
				[aktiveEntscheidung addIfBefehl:neueEntsch];
			}
			[neueEntsch setVorgaenger:[aktiveEntscheidung vorgaenger]];
			[neueEntsch release];
			NSString* cond = [attributeDict objectForKey:@"cond"];
			if (cond) {
				[neueEntsch setBedingung:cond];
			}
			else {
				fehler = @"<elseif> benoetigt das Attribut cond, in der die Bedingung steht.";
				[xmlParser abortParsing];
			}
			aktiveEntscheidung = neueEntsch;
		}
		else {
			fehler = @"<elseif/> kann nur innerhalb von <if> stehen.";
			[xmlParser abortParsing];
		}
	return;
	}
	
#pragma mark ------------------ clear	
	
	if ([tag isEqualToString:@"clear"]) {
		if ([aktiverTag isEqualToString:@"block"] || [aktiverTag isEqualToString:@"filled"] || [aktiverTag isEqualToString:@"if"]) {
			Clear* clear = [[Clear alloc] init];
			if ([aktiverTag isEqualToString:@"block"]) {
				[(Block*)aktivesFormitem addAktionsbefehl:clear];
			}
			else if ([aktiverTag isEqualToString:@"filled"]){
				[aktiverFilled addAktionsbefehl:clear];
			}
			else {
				BOOL elseZweig = [aktiveEntscheidung elseZweig];
				if (elseZweig == YES) {
					[aktiveEntscheidung addElseBefehl:clear];
				} 
				else {
					[aktiveEntscheidung addIfBefehl:clear];
				}
			}
			[clear release];
			NSString* string = [attributeDict objectForKey:@"namelist"];
			if (string) {
				NSArray* namelist = [string componentsSeparatedByString:@" "];
				int k;
				for (k = 0; k < [namelist count]; k++) {
					Memo* memo = [[Memo alloc] init];
					[memo setBefehl:tag];
					[memo setInhalt:[namelist objectAtIndex:k]];
					[memo setLineNumber:[xmlParser lineNumber]];
					[aktiverAutomat addMemo:memo];
					[memo release];
				}
				[clear setNamelist:namelist];
			} 
			else {
				fehler = @"Das Attribut namelist fehlt.";
				[xmlParser abortParsing];
			}
		}
		else {
			fehler = @"<clear> kann nur in Bloecke oder Aktionen eingebunden werden.";
			[xmlParser abortParsing];
		}
	return;
	}
}

- (void)parser:(NSXMLParser *)xmlParser didEndElement:(NSString *)tag namespaceURI:(NSString *)namespaceURI qualifiedName:(NSString *)qName
{
	if ([tag isEqualToString:@"form"]) {
		if ([aktiverTag isEqualToString:@"form"]) {
			[aktiverZustand setAktiv:NO];
			aktiverTag = @"vxml";
		}
		else {
			fehler = @"Das Formular kann hier noch nicht geschlossen werden.";
			[xmlParser abortParsing];
		}
		return;
	}
    if ([tag isEqualToString:@"menu"]) {
		if ([aktiverTag isEqualToString:@"menu"]) {
			[aktiverZustand setAktiv:NO];
			aktiverTag = @"vxml";
		}
		else {
			fehler = @"Das Menue kann hier noch nicht geschlossen werden.";
			[xmlParser abortParsing];
		}
		return;
	}
    if ([tag isEqualToString:@"field"]) {
		if ([aktiverTag isEqualToString:@"field"]) {
			[aktivesFormitem setAktiv:NO];
			aktiverTag = @"form";
		}
		else {
			fehler = @"Das Feld kann hier noch nicht geschlossen werden.";
			[xmlParser abortParsing];
		}
		return;
	}
	if ([tag isEqualToString:@"block"]) {
		if ([aktiverTag isEqualToString:@"block"]) {	
			[aktivesFormitem setAktiv:NO];
			aktiverTag = @"form";
		}
		else {
			fehler = @"Der Block kann hier noch nicht geschlossen werden.";
			[xmlParser abortParsing];
		}
		return;
	}	
	if ([tag isEqualToString:@"filled"]) {
		if ([aktiverTag isEqualToString:@"filled"]) {
			aktiverTag = [aktiverFilled vorgaenger];
		}
		else {
			fehler = @"Die Aktion (filled) kann hier noch nicht geschlossen werden.";
			[xmlParser abortParsing];
		}
	}
	if ([tag isEqualToString:@"prompt"]) {
		if ([aktiverTag isEqualToString:@"prompt"]) {
			aktiverTag = [aktiverPrompt vorgaenger];
		}
		else {
			fehler = @"Der Prompt kann hier nicht geschlossen werden.";
			[xmlParser abortParsing];
		}
	return;
	}
	if ([tag isEqualToString:@"option"]) {
		if ([aktiverTag isEqualToString:@"option"]) {
			aktiverTag = @"field";
		}
		else {
			fehler = @"Die Option kann hier nicht geschlossen werden.";
			[xmlParser abortParsing];
		}
	return;
	}
	if ([tag isEqualToString:@"choice"]) {
		if ([aktiverTag isEqualToString:@"choice"]) {
			aktiverTag = @"menu";
		}
		else {
			fehler = @"<choice> kann hier nicht geschlossen werden.";
			[xmlParser abortParsing];
		}
	return;
	}
	if ([tag isEqualToString:@"if"]) {
		if ([aktiverTag isEqualToString:@"if"]) {
			[aktiveEntscheidung setElseZweig:NO];
			id vorgaenger = [aktiveEntscheidung vorgaenger];
			if ([vorgaenger isKindOfClass:[Filled class]]) {
				aktiverTag = @"filled";
			}
			else if ([vorgaenger isKindOfClass:[Block class]]) {
				aktiverTag = @"block";
			}
			else {
				aktiveEntscheidung = vorgaenger;
				aktiverTag = @"if";
			}
		}
		else {
			fehler = @"<if> kann hier nicht geschlossen werden.";
			[xmlParser abortParsing];
		}
	return;
	}
}


- (void)parser:(NSXMLParser *)parser foundCharacters:(NSString *)string
{
	if ([aktiverTag isEqualToString:@"prompt"]) {
		[aktiverPrompt setStringListe:string];
		//NSLog(@"%@ %@", aktiverTag, [aktiverPrompt description]);
	}
	if ([aktiverTag isEqualToString:@"option"]) {
		[aktiveOption setString:string];
		if (![aktiveOption valueGesetzt]) {
			[aktiveOption setValue:string];
		}
		//NSLog(@"%@ %@", aktiverTag, [aktiveOption description]);
	}
	if ([aktiverTag isEqualToString:@"choice"]) {
		[aktiveChoice setString:string];
		//NSLog(@"%@ %@", aktiverTag, [aktiveChoice description]);
	}
}

- (void)parser:(NSXMLParser*)xmlParser parseErrorOccurred:(NSError*)err
{
//NSLog(@" geht in fehlerproz mit fehler nr %i", [err code]);
	NSString* fehlerbeschreibung;
	BOOL abbruch = NO;
	switch ([err code]) {
	case 512:
		fehlerbeschreibung = fehler;
		break;
	case 5:
		fehlerbeschreibung = @"Das Dokument wurde unerwartet beendet.";
		break;
	case 73:
		fehlerbeschreibung = @"Schliessende spitze Klammer erwartet.";
		break;
	case 76:
		fehlerbeschreibung = @"Der Tag kann hier nicht geschlossen werden.";//tag name mismatch
		abbruch = YES;
		break;
	default:
		fehlerbeschreibung = [err localizedDescription];
		break;
	}
	NSString* fehlertext = [NSString stringWithFormat:@"Fehler gefunden:\nFehlernr. %i, Zeile: %i\nBeschreibung: %@", [err code], 
        [xmlParser lineNumber], fehlerbeschreibung];
	[syntaxfehlerView setString:fehlertext];
	if (abbruch) {
		[xmlParser abortParsing];
	}
	
	//Fehlerzeile markieren
	NSString* derCode = [codeView string];
	NSArray* codeZeilen = [derCode componentsSeparatedByString:@"\n"];
	int k;
	int erstesZeichen = 0;
	int laenge;
	for (k=0; k < [xmlParser lineNumber]; k++) {
		if (k == [xmlParser lineNumber]-1) {
			laenge = [[codeZeilen objectAtIndex:k] length];
		}
		else {
			erstesZeichen += [[codeZeilen objectAtIndex:k] length] + 1;
		}
	}
	[codeView setSelectedRange:NSMakeRange(erstesZeichen,laenge)];

}

#pragma mark Methoden fuer die modelView
-(void)oeffneModellPanel:(id)element:(BOOL)dk aktion:(BOOL)ak
{	
	//Formular* element = [[Formular alloc] init];
	//NSLog(@"Typ %@ und Titel %@", [element typ], [element titel]);
	[applicationController showModellPanel:element :self :dk aktion:ak];
}

-(void)setzeMehrfachPanel
{
	[applicationController setzeMehrfachPanel];
}

#pragma mark Methoden vom ausfuehrungsDraw
- (IBAction)dtmf0:(id)sender
{
	//int i = 0;
	NSString* string = @"ab.substring(3,5)";
	string = [string substringToIndex:12];
	string = [string substringFromIndex:2];
	//float einF = [string floatValue];
//NSLog(@"%@", string);
	//int anf = 1;
	//int ende = 7;
	//NSString* string3 = [NSString stringWithFormat:@"\n%@\n%@", [string substringToIndex:anf], [string substringFromIndex:1]];

	//NSLog(@"berechung %d", (int)istb8);
	//int k = [string length];
	//NSString* string2 = [string substringToIndex:k-1];
	//string2 = [string2 substringFromIndex:1];
	//[modelfehlerView insertText:@"0"];
	//NSString* systemausgabe = @"System: ggg\n";
	//NSAttributedString* attrString = [[NSAttributedString alloc] initWithString:systemausgabe
	//															attributes:systemText];
	//[dialogView insertText:string];
	//[dialogView insertText:string3];
}

- (IBAction)dtmf1:(id)sender
{
	//int i = 1;
	[modelfehlerView insertText:@"1"];
}

- (IBAction)dtmf2:(id)sender
{
	//int i = 2;
	[modelfehlerView insertText:@"2"];
	Variable* var = [[Variable alloc] init];
	[var setName:@"var1"];
	[var setExpr:@"45"];
	[self setzeVariable:var];
	Variable* var2 = [[Variable alloc] init];
	[var2 setName:@"var2"];
	[var2 setExpr:@"var1"];
	[self setzeVariable:var2];
	if (fehlerPassiert == NO) {
	//NSLog(@"%@ %@", [var name], [var expr]);
	//NSLog(@"%@ %@", [var2 name], [var2 expr]);
	}
	else {
	//NSLog(@"%@", fehler);
	}
}

- (IBAction)dtmf3:(id)sender
{
	//int i = 3;
	[modelfehlerView insertText:@"3"];
}

- (IBAction)dtmf4:(id)sender
{
	//int i = 4;
	[modelfehlerView insertText:@"4"];
}

- (IBAction)dtmf5:(id)sender
{
	//int i = 5;
	[modelfehlerView insertText:@"5"];
}

- (IBAction)dtmf6:(id)sender
{
	//int i = 6;
	[modelfehlerView insertText:@"6"];
}

- (IBAction)dtmf7:(id)sender
{
	//int i = 7;
	[modelfehlerView insertText:@"7"];
}

- (IBAction)dtmf8:(id)sender
{
	//int i = 8;
	[modelfehlerView insertText:@"8"];
}

- (IBAction)dtmf9:(id)sender
{
	//int i = 9;
	[modelfehlerView insertText:@"9"];
}

- (IBAction)dtmfAsterisk:(id)sender
{
	//int i = 10;
	[modelfehlerView insertText:@"*"];
}

- (IBAction)dtmfDiamond:(id)sender
{
	//int i = 11;
	[modelfehlerView insertText:@"#"];
}

- (IBAction)ohneSprache:(id)sender
{
	int i = [sprachCheck state];
	//hier bescheid geben, ob mit oder ohne sprache getestet wird
	//also ein Funktionsaufruf, der i weitergibt
	
	
	//nur Test
	if (i == 1) {
		testMitSprache = NO;
	}
	else {
		testMitSprache = YES;
	}
	NSLog(@"test mit sprache %d", (int)testMitSprache);
}

#pragma mark AUSFUEHRUNG

- (IBAction)starteDialog:(id)sender
{
	if (!dialogLaeuft) {
		dialogLaeuft = YES;
		[sender setImage:[NSImage imageNamed:@"auflegen.tif"]];
		[dialogView setString:@""];
		protokoll = [[NSMutableAttributedString alloc] initWithString:@""];
		//dialogBeendet = NO;
		//starteDialog = NO;
		[self parse];
		fehlerPassiert = NO;
		
		//Variablen setzen von dem Automaten
		NSMutableArray* variablen = [aktiverAutomat variablen];
	//NSLog(@"anz vars in automat %d",[variablen count]);
		int k;
		for (k = 0; k < [variablen count]; k++) {
			[self setzeVariable:[variablen objectAtIndex:k]];
			if (fehlerPassiert == YES) {
				break;
			}
		}
		if (fehlerPassiert == YES) {
			[dialogView insertText:fehler];
			return;
		}
		
		//wenn es keine zustaende gibt, passiert nichts
		if ([[aktiverAutomat eListe] count] == 0) {
			return;
		}
		
		//erstes Element in den start schicken
		[aktiverAutomat setzeAktivesMElement:[[aktiverAutomat eListe] objectAtIndex:0]];
		[aktiverAutomat setzeKommando:@"zustandAusfuehren"];	
		[aktiverAutomat delegiereAblauf];
	}
	else {
		[sender setImage:[NSImage imageNamed:@"abheben.tif"]];
		dialogLaeuft = NO;
		//starteDialog = NO;
		//dialogBeendet = YES;
		[synthesizer stopSpeaking];
		[protokoll release];
		[recog stopListening];
	}

	
}

-(id)fuehreZustandAus:(MElement*)zustand
{
	if ([[zustand typ] isEqualToString:@"Formular"]) {
		
		aktiverTag = @"formular";
		aktiverZustand = zustand;
		//suche naechstes Formitem
		NSMutableArray* feldliste = [(Formular*)zustand feldliste];
		MElement* formitem;
		int k;
		BOOL ungefuelltesFeldGefunden = NO;
		BOOL auszufuehrendenBlockGefunden = NO;
		BOOL ersterEintrittInsFormular = NO;
		for (k=0; k < [feldliste count]; k++) {
			formitem = [feldliste objectAtIndex:k];
			if ([[formitem typ] isEqualToString:@"Feld"]) {
				if ([(Feld*)formitem gesetzt] == NO) {
					ungefuelltesFeldGefunden = YES;
					if (k==0) {
						ersterEintrittInsFormular = YES;
					}
					break;
				}
				else if ([(Feld*)formitem boolAktion] == YES) {
					if ([[(Feld*)formitem filled] gesetzt] == NO) {
						auszufuehrendenBlockGefunden = YES;
						formitem = [(Feld*)formitem filled];
						break;
					}
				}
			}
			else {	
				if ([(Block*)formitem gesetzt] == NO) {
					auszufuehrendenBlockGefunden = YES;
					if (k==0) {
						ersterEintrittInsFormular = YES;
					}
					break;
				}
			}
		}
		
		//wenn das Formular neu betreten wurde, Variablen setzen
		if (ersterEintrittInsFormular == YES) {
			NSMutableArray* variablen = [(Formular*)zustand variablen];
		//NSLog(@"anz vars in formular %d",[variablen count]);
			for (k = 0; k < [variablen count]; k++) {
				[self setzeVariable:[variablen objectAtIndex:k]];
				if (fehlerPassiert == YES) {
					[aktiverAutomat setzeKommando:@"fehler"];
					return nil;
				}
			}
		}
		
		//wenn unsausgefuehrtes Formitem gefunden, fuehre es aus
		if (ungefuelltesFeldGefunden == YES) {
			[aktiverAutomat setzeKommando:@"feldMenueAusfuehren"];
			[aktiverAutomat setzeVaterVonAktivemMElement];
			return formitem;
		}
		if (auszufuehrendenBlockGefunden == YES) {
			[aktiverAutomat setzeKommando:@"aktionBlockAusfuehren"];
			[aktiverAutomat setzeVaterVonAktivemMElement];
			return formitem;
		}
		if ([(Formular*)zustand boolAktion] == YES) {
			if ([[(Formular*)zustand filled] gesetzt] == NO) {
				[aktiverAutomat setzeKommando:@"aktionBlockAusfuehren"];
				[aktiverAutomat setzeVaterVonAktivemMElement];
				return [(Formular*)zustand filled];
			}
		}
		
		dialogLaeuft = NO;
		[startStopButton setImage:[NSImage imageNamed:@"abheben.tif"]];
		[protokoll release];
		return nil;
	}
	
	if ([[zustand typ] isEqualToString:@"Menue"]) {
		aktiverTag = @"menu";
		[aktiverAutomat setzeKommando:@"feldMenueAusfuehren"];
		return zustand;
	}
	return nil;
}

-(void)fuehreAktionBlockAus:(MElement*)zustand
{
	NSMutableArray* befehle;
	if ([zustand isMemberOfClass:[Filled class]]) {
		aktiverTag = @"filled";
		aktiverFilled = (Filled*)zustand;
		befehle = [(Filled*)zustand aktiveBefehle];
	//NSLog(@"zustand ist filled");
	}
	else {
		aktiverTag = @"block";
		aktivesFormitem = (Block*)zustand;
		befehle = [(Block*)zustand aktiveBefehle];
	}
	
	BOOL formFilledZurueck = NO;
	int k;
	for (k=0; k < [befehle count]; k++) {
	//NSLog(@"%@", [[befehle objectAtIndex:k] description]);
		if ([[befehle objectAtIndex:k] isMemberOfClass:[Goto class]]) {
			NSString* next = [(Goto*)[befehle objectAtIndex:k] next];
			next = [next substringFromIndex:1];
			MElement* naechsterZustand = [self gibFormularMitTitel:next];
			
			//felder gestzt = no, filled der felder = no, filled des formulars = no
			//[(Formular*)naechsterZustand clearAll];
			if ([[aktiverAutomat aktivesMElement] isMemberOfClass:[Formular class]]) {
				[(Formular*)[aktiverAutomat aktivesMElement] clearAll];
			}
			else {
				[(Formular*)[aktiverAutomat vaterVonAktivemMElement] clearAll];
			//NSLog(@"%@", [[aktiverAutomat vaterVonAktivemMElement] description]);
			}
			//befehle des gerade aktiven blocks/fields zuruecksetzen
			[zustand setzeBefehleZurueck];
			if ([zustand isMemberOfClass:[Filled class]]) {
			//NSLog(@"aktives formitem %@", [aktivesFormitem description]);
			//	if ([aktivesFormitem isMemberOfClass:[Feld class]]) {
			//		NSString* varName = [(Feld*)aktivesFormitem titel];
			//		[zustand removeVariableMitName:varName];
				//NSLog(@"%@", [zustand description]);
			//	}
			}
			[aktiverAutomat setzeAktivesMElement:naechsterZustand];
			[aktiverAutomat setzeKommando:@"zustandAusfuehren"];
			[aktiverAutomat delegiereAblauf];
			return;

		}
		
		if ([[befehle objectAtIndex:k] isMemberOfClass:[Clear class]]) {
			if ([[befehle objectAtIndex:k] abgespielt] == NO) {
				[[befehle objectAtIndex:k] setAbgespielt:YES];
				[zustand addInRuecksetzliste:[befehle objectAtIndex:k]];
				NSArray* namelist = [(Clear*)[befehle objectAtIndex:k] namelist];
				Formular* formular;
				formular = (Formular*)[aktiverAutomat vaterVonAktivemMElement];
				int j;
				NSMutableArray* feldliste = [formular feldliste];
				for (j=0; j < [namelist count]; j++) {
					int m;
					MElement* formitem;
					for (m=0; m<[feldliste count]; m++) {
						formitem = [feldliste objectAtIndex:m];
						if ([[namelist objectAtIndex:j] isEqualToString:[formitem titel]]) {
							[(Feld*)formitem setGesetzt:NO];
							[[(Feld*)formitem filled] setGesetzt:NO];
						//NSLog(@"anz der formular variablen %d", [[formular variablen] count]);
							[formular removeFeldvariableMitName:[formitem titel]];
							//[[(Feld*)formitem filled] removeVariableMitName:[formitem titel]];
						//NSLog(@"anz der formular variablen %d", [[formular variablen] count]);
						//NSLog(@"anz der filled variablen %d", [[[(Feld*)formitem filled] variablen] count]);
							break;
						}
					}
				}
				formFilledZurueck = YES;

			}
		}
		
		if ([[befehle objectAtIndex:k] isMemberOfClass:[Variable class]]) {
			if ([[befehle objectAtIndex:k] abgespielt] == NO) {
				if ([[befehle objectAtIndex:k] gibDefinition] == NO) {
					Variable* assign = [befehle objectAtIndex:k];
					[assign setAbgespielt:YES];
					NSString* wert = [self berechneWertVonAusdruck:[assign expr]];
					if (fehlerPassiert == YES) {
					//NSLog(@"fehler passiert 1");
						return;
					}
					Variable* var = [self gibVariableMitName:[assign name] mitPunkt:YES];
					if (fehlerPassiert == YES) {
					//NSLog(@"fehler passiert 2");
						return;
					}
					[var setWert:wert];
				}
				else {
					Variable* var = [befehle objectAtIndex:k];
					[self setzeVariable:var];
					if (fehlerPassiert == YES) {
					//NSLog(@"fehler passiert 3");
						return;
					}
				}
			}
		}
		
		if ([[befehle objectAtIndex:k] isMemberOfClass:[Prompt class]]) {
			if ([[befehle objectAtIndex:k] abgespielt] == NO) {
				[[befehle objectAtIndex:k] setAbgespielt:YES];
				[zustand addInRuecksetzliste:[befehle objectAtIndex:k]];
				NSMutableArray* prompts = [[NSMutableArray alloc] init];
				[prompts addObject:[befehle objectAtIndex:k]];
				NSMutableAttributedString* ausdruckM = [self setzePrompts:prompts];
				NSString* ausdruck = [ausdruckM string];
				if (fehlerPassiert == YES) {
					return;
				}
				justSpeaking = YES;
				NSLog(@"im prompt ausfuehren");
				[synthesizer startSpeakingString:ausdruck];
				NSString* string = [NSString stringWithFormat:@"System: %@\n", ausdruck];
				NSAttributedString* attrString = [[NSAttributedString alloc] initWithString:string
																	attributes:systemText];
				//[dialogView setSelectedRange:NSMakeRange([[dialogView string] length],0)];
				[protokoll removeAttribute:NSLinkAttributeName range:NSMakeRange(0,[protokoll length])];
				[protokoll appendAttributedString:attrString];
				[dialogView setString:@""];
				[dialogView insertText:protokoll];
				[attrString release];
				[prompts release];
				return;
			}
		}
		
		if ([[befehle objectAtIndex:k] isMemberOfClass:[Entscheidung class]]) {
			if ([[befehle objectAtIndex:k] abgespielt] == NO) {
				Entscheidung* entsch = [befehle objectAtIndex:k];
				[entsch setAbgespielt:YES];
				[zustand addInRuecksetzliste:[befehle objectAtIndex:k]];
				NSString* bedingung = [entsch bedingung];
				NSLog(@"bedingung %@", bedingung);
				BOOL ergebnis = [self werteBedingungAus:bedingung];
				if (fehlerPassiert == YES) {
					return;
				}
				NSMutableArray* neueBefehle;
				if (ergebnis == YES) {
					neueBefehle = [entsch ifBefehle];
					NSLog(@"neue befehle %d", [neueBefehle count]);
				}
				else {
					neueBefehle = [entsch elseBefehle];
				}
				int j;
				for (j = [neueBefehle count]-1; j >= 0; j--) {
					[befehle insertObject:[neueBefehle objectAtIndex:j] atIndex:k+1];
					
				}
				NSLog(@"insgesamt %d", [befehle count]);
			}
		}
	}
	
	[zustand setGesetzt:YES];
	[zustand setzeBefehleZurueck];
	if (formFilledZurueck == YES) {
		[[(Formular*)[aktiverAutomat vaterVonAktivemMElement] filled] setGesetzt:NO];
	}
	
	if ([zustand isMemberOfClass:[Filled class]]) {
		if ([[aktiverAutomat aktivesMElement] isMemberOfClass:[Feld class]]) {
			NSString* varName = [(Feld*)[aktiverAutomat aktivesMElement] titel];
			[zustand removeVariableMitName:varName];
		}
	}
	

	[aktiverAutomat setzeKommando:@"zustandAusfuehren"];
	[aktiverAutomat setzeAktivesMElement:[aktiverAutomat vaterVonAktivemMElement]];
	[aktiverAutomat delegiereAblauf];
}



-(void)fuehreFeldMenueAus:(MElement*)zustand
{
	
	NSLog(@"test mit sprache %d", (int)testMitSprache);
	
	NSMutableArray* aktuellePrompts;
	//filled zuruecksetzen
	//wenn ein feld (ein weiteres mal) ausgefuehrt wird, kann der filled nicht mehr gesetzt sein
	if ([[zustand typ] isEqualToString:@"Feld"]) {
		[[(Feld*)zustand filled] setGesetzt:NO];
		[(Feld*)zustand erhoeheDurchlauf];
		aktivesFormitem = (Feld*)zustand;
		aktuellePrompts = [(Feld*)zustand gibAktuellePrompts];
	}
	else {
		[(Menu*)zustand erhoeheDurchlauf];
		aktiverZustand = (Menu*)zustand;
		aktuellePrompts = [(Menu*)zustand gibAktuellePrompts];
	}
	
	//setze Systemausgabe
	NSMutableAttributedString* ausgabe = [self setzePrompts:aktuellePrompts];
	
	//wenn es geklappt hat, start speaking
	if (ausgabe != nil) {
		NSString* nonAttr = [ausgabe string];
		[synthesizer startSpeakingString:nonAttr];
		
		NSAttributedString* systemString = [[NSAttributedString alloc] initWithString:@"System: " attributes:systemText];
		NSAttributedString* nextLine = [[NSAttributedString alloc] initWithString:@"\n" attributes:systemText];
		[ausgabe insertAttributedString:systemString atIndex:0];
		[ausgabe appendAttributedString:nextLine];
		//[dialogView setSelectedRange:NSMakeRange([[dialogView string] length],0)];
		[protokoll removeAttribute:NSLinkAttributeName range:NSMakeRange(0,[protokoll length])];
		[protokoll appendAttributedString:ausgabe];
		[dialogView setString:@""];
		[dialogView insertText:protokoll];
		
		[systemString release];
		[nextLine release];		
	}
	else {
		//fehler passiert an dialogView oder synth
	}
	
	
	
	//Auswahl setzen
	
	if (testMitSprache == YES) {
		int k;
		NSMutableArray* auswahl;
		[commands removeAllObjects];
		if ([[zustand typ] isEqualToString:@"Feld"]) {
			auswahl = [(Feld*)zustand options];
			Option* op;
			for (k = 0; k < [auswahl count]; k++) {
				op = [auswahl objectAtIndex:k];
				[commands addObject:[op string]];
			}
		}
		else {
			auswahl = [(Menu*)zustand choices];
			Choice* choice;
			for (k = 0; k < [auswahl count]; k++) {
				choice = [auswahl objectAtIndex:k];
				[commands addObject:[choice string]];
			}
		}
		[recog setCommands:commands];
		[recog startListening];
	}
	else {
		eingabeWirdErwartet = YES;
		//timer = [NSTimer scheduledTimerWithTimeInterval:9
		//	target:self 
		//	selector:@selector(noInput:)  
		//	userInfo:@""
		//	repeats:NO];
	}
	

				
	
}


- (void)speechSynthesizer:(NSSpeechSynthesizer *)sender didFinishSpeaking:(BOOL)success
{
	NSLog(@"finish speakung bool %d", (int)success);
	if (success == YES) {
		if (justSpeaking == YES) {
			NSLog(@"justSpeaking == YES");
			justSpeaking = NO;
			[aktiverAutomat setzeKommando:@"aktionBlockAusfuehren"];
			[aktiverAutomat delegiereAblauf];
		}
		else {//Timer setzen
			NSLog(@"justSpeaking == NO");
			if (testMitSprache == YES) {
				NSLog(@"testMitSprache == YES");
				timer = [NSTimer scheduledTimerWithTimeInterval:9
					target:self 
					selector:@selector(noInput:)  
					userInfo:@""
					repeats:NO];
			}
		}
	}
	else {
		if (dialogLaeuft) {
			//[aktiverAutomat setzeAktivesMElement:[aktiverAutomat vaterVonAktivemMElement]];
			[aktiverAutomat setzeKommando:@"zustandAusfuehren"];
			[aktiverAutomat delegiereAblauf];
		}
	}
}

- (void)noInput:(NSTimer *)timers 
{	
	if (dialogLaeuft) {
		if (testMitSprache == YES) {
			[recog stopListening];
		}
		[[aktiverAutomat aktivesMElement] erhoeheDurchlauf];
		[aktiverAutomat setzeKommando:@"feldMenueAusfuehren"];
		[aktiverAutomat delegiereAblauf];
	}


}

- (void)speechRecognizer:(NSSpeechRecognizer *)sender didRecognizeCommand:(id)aCmd
{
	[timer invalidate];
	timer = nil;
	[sender stopListening];
	[self saveInput:(NSString*)aCmd];
	//[aktiverAutomat setzeAktivesMElement:[aktiverAutomat vaterVonAktivemMElement]];
	[aktiverAutomat setzeKommando:@"zustandAusfuehren"];
	[aktiverAutomat delegiereAblauf];
}

- (BOOL)textView:(NSTextView *)aTextView clickedOnLink:(id)link atIndex:(unsigned)charIndex
{
	if (eingabeWirdErwartet == YES) {
	//	[timer invalidate];
		
		eingabeWirdErwartet = NO;
		[self saveInput:(NSString*)link];
		
		if([synthesizer isSpeaking]) {
			[synthesizer stopSpeaking];
		}
		else {
			//[aktiverAutomat setzeAktivesMElement:[aktiverAutomat vaterVonAktivemMElement]];
			[aktiverAutomat setzeKommando:@"zustandAusfuehren"];
			[aktiverAutomat delegiereAblauf];
		}
	}
	return YES;
}
-(void)saveInput:(NSString*)userInput
{
	NSString* benutzereingabe = [NSString stringWithFormat:@"Benutzer: %@\n", userInput];
	NSAttributedString* attrString = [[NSAttributedString alloc] initWithString:benutzereingabe
																attributes:benutzerText];
	//[dialogView setSelectedRange:NSMakeRange([[dialogView string] length],0)];
	[protokoll removeAttribute:NSLinkAttributeName range:NSMakeRange(0,[protokoll length])];
	[protokoll appendAttributedString:attrString];
	[dialogView setString:@""];
	[dialogView insertText:protokoll];
	[attrString release];
	
	
	//command speichern als Wert, nur bei Feld
	
	if ([[[aktiverAutomat aktivesMElement] typ] isEqualToString:@"Feld"]) {
		Variable* var = [[Variable alloc] init];
		Feld* aktiv = (Feld*)[aktiverAutomat aktivesMElement];
		[var setName:[aktiv titel]];
		NSString* neuerWert = [aktiv gibOptionfuerKommando:userInput];
		neuerWert = [NSString stringWithFormat:@"'%@'", neuerWert];
		[var setWert:neuerWert];
		[var setExpr:neuerWert];
		//NSLog(@"neue feldvar name:%@ wert: ---%@---", [var name], [var wert]);
		[var setOwner:[aktiverAutomat vaterVonAktivemMElement]];
		[var setGesetzt:YES];
		[var setTyp:[aktiv exprTyp]];
		[[aktiverAutomat vaterVonAktivemMElement] addFeldvariable:var];
		
		//if ([aktiv boolAktion] == YES) {
		//	[[aktiv filled] addVariable:var];
		//}
		//block braucht das auch nocvh!!!!!!!
	//NSLog(@"%@", [[aktiverAutomat vaterVonAktivemMElement] description]);
	//NSLog(@"neue feldvar von %@ name:%@ wert:%@ aktiverTag %@", [var owner], [var name], [var wert], aktiverTag);
		[var release];
//NSLog(@"retain count von %@ ist %d", [var name], [var retainCount]);
		[aktiv setGesetzt:YES];
		[aktiv setDurchlauf];
		[aktiverAutomat setzeAktivesMElement:[aktiverAutomat vaterVonAktivemMElement]];
		return;
	}
	
	//bei Menue entscheidet das Kommando, welches Formular das naechste aktive sein wird
	else {
		Menu* aktiv = (Menu*)[aktiverAutomat aktivesMElement];
		[aktiv setDurchlauf];
		NSMutableArray* choices = [aktiv choices];
		int k;
		Choice* aktuelleChoice;
		for (k=0; k<[choices count]; k++) {
			aktuelleChoice = [choices objectAtIndex:k];
			if ([userInput isEqualToString:[aktuelleChoice string]]) {
				break;
			}
		}
		NSString* next = [aktuelleChoice next];
		MElement* naechsterZustand = [self gibFormularMitTitel:next];
		[aktiverAutomat setzeAktivesMElement:naechsterZustand];
		//[aktiverAutomat setzeKommando:@"zustandAusfuehren"];
		//[aktiverAutomat delegiereAblauf];
		return;
	}

}



-(MElement*)gibFormularMitTitel:(NSString*)name
{
	MElement* formular;
	NSMutableArray* zustandsliste = [aktiverAutomat eListe];
	NSString* neuerName;
	int k;
	for (k=0; k< [zustandsliste count]; k++) {
			formular = [zustandsliste objectAtIndex:k];
			if ([name isEqualToString:[(Formular*)formular titel]]) {
				break;
			}
			else {
				BOOL raute = [self istErstesZeichenRaute:name];
				if (raute == YES) {
					neuerName = [name substringFromIndex:1];
					if ([neuerName isEqualToString:[(Formular*)formular titel]]) {
						break;
					}
				}
			}
	}
	return formular;
}


-(NSMutableAttributedString*)setzePrompts:(NSMutableArray*)promptArray
{
	int k;
	NSMutableArray* stringListe;
	NSMutableArray* varListe;
	Prompt* prompt;
	NSString* ausgabe = @"";
	NSMutableAttributedString* ausgabeM;
	for (k=0; k < [promptArray count]; k++) {
		
		prompt = [promptArray objectAtIndex:k];
		stringListe = [prompt stringListe];
		varListe = [prompt varListe];
		NSString* wert;
		if ([stringListe count] != 0) {
			int m;
			for (m=0; m < [stringListe count]; m++) {
				
				ausgabe = [NSString stringWithFormat:@"%@%@", ausgabe, [stringListe objectAtIndex:m]];
				
				if ([varListe count] <= m) {
					//if (m+1 == [stringListe count]) {
						wert = @"";
					//}
					//else {
					//return nil;
					//}
				}
				else {
					wert = [varListe objectAtIndex:m];
					wert = [self setzeAusdruck:wert];
					if (fehlerPassiert == YES) {
						return nil;
					}
				}
				ausgabe = [NSString stringWithFormat:@"%@%@", ausgabe, wert];
			}
		}
		ausgabeM = [[NSMutableAttributedString alloc] initWithString:ausgabe attributes:systemText];
		if ([prompt enumerate] == YES) {
			int k;
			NSMutableArray* auswahl;
			NSString* naechsteWahl;
			NSString* naechsteWahlF;
			int laenge;
			int laengeM;
			if ([[[aktiverAutomat aktivesMElement] typ] isEqualToString:@"Feld"]) {
				Feld* feld = (Feld*)[aktiverAutomat aktivesMElement];
				auswahl = [feld options];
			}
			else {
				Menu* menue = (Menu*)[aktiverAutomat aktivesMElement];
				auswahl = [menue choices];
			}
			for (k = 0; k < [auswahl count]; k++) {
				naechsteWahl = [[auswahl objectAtIndex:k] string];
				naechsteWahlF = [NSString stringWithFormat:@" %@", naechsteWahl];
				NSAttributedString* naechsteWahlM = [[NSAttributedString alloc] initWithString:naechsteWahlF attributes:systemText];
				[ausgabeM appendAttributedString:naechsteWahlM];
				laenge = [naechsteWahl length];
				laengeM = [ausgabeM length];
				if (testMitSprache == NO) {
					//[dialogView ]
					[ausgabeM addAttribute:NSLinkAttributeName value:naechsteWahl range:NSMakeRange(laengeM - laenge,laenge)];
				}
				NSLog(@"range (%d,%d) laengeM %d ", laengeM -laenge, laenge, laengeM);
				[naechsteWahlM release];
				//ausgabe = [NSString stringWithFormat:@"%@ %@", ausgabe, naechsteWahl];
			}
		}
	}
		//display string in der dialogView
			
	//	[ausgabeM addAttribute:NSLinkAttributeName
    //           value:@"option"
    //           range:selectedRange];

	[ausgabeM autorelease];
	return ausgabeM;
}


	



-(NSString*)setzeAusdruck:(NSString*)wert
{
	const char* charString = [wert cStringUsingEncoding:NSASCIIStringEncoding];
//NSLog(@"rein mit wert ----%@---", wert);
//remove white spaces am anfang und ende
	int k;
	for (k = [wert length]-1; k > 0 ; k--) {
		if (charString[k]== ' ') {
			wert = [NSString stringWithFormat:@"%@", [wert substringToIndex:k]];
		//NSLog(@"letzter ist freizeichen, %@----", wert);
		} else {break;}
	}
	for (k = 0; k<[wert length] ; k++) {
		if (charString[k]== ' ') {
			wert = [NSString stringWithFormat:@"%@", [wert substringFromIndex:k+1]];
			charString = [wert cStringUsingEncoding:NSASCIIStringEncoding];
		//NSLog(@"erster ist freizeichen, ----%@----", wert);
			k--;
		} else {break;}
	}
//NSLog(@"ohne freizeichen ----%@----", wert);
	charString = [wert cStringUsingEncoding:NSASCIIStringEncoding];

	if ([self istZahl:wert mitPunkt:NO] == YES) {
		return wert;
	}
	else {
		int laenge = [wert length];
		//NSLog(@"----%@----", wert);
		//NSLog(@"----12345678901234567, laenge %d", laenge);
		//NSLog(@"erster und letzter %c %c von %@", charString[0], charString[laenge-1], wert);
		if (charString[0] == 39 && charString[laenge-1] == 39) {
			wert = [wert substringToIndex:laenge-1];
			wert = [wert substringFromIndex:1];
		//NSLog(@"ganz raus mit string %@", wert);
			return wert;
		}
		else {
			NSString* istStringVeraenderung = [self istStringVeraenderung:wert];
			if (fehlerPassiert == YES) {
				return nil;
			}
			if ([istStringVeraenderung isEqualToString:@"%%%"]) {
			//NSLog(@"vor dem ersetzen %@", wert);
				wert = [self ersetzeVariablenInAusdruck:wert];
			//NSLog(@"nach dem ersetzen %@", wert);
				if (fehlerPassiert == YES) {
					return nil;
				}
				else {
				//NSLog(@"nochmal rein mit wert %@", wert);
					return [self setzeAusdruck:wert];
				}
			}
			else {
				wert = istStringVeraenderung;
				return wert;//[self setzeAusdruck:wert];
			}
		}
	}
	return nil;
}

-(void)setzeVariable:(Variable*)var
{
//NSLog(@"setzte variable %@", [var name]);
	NSString* wert;
	NSString* neuerWert;
	wert = [var expr];
	if (wert) {
		if ([wert isEqualToString:@"true"] || [wert isEqualToString:@"false"]) {
			[var setTyp:@"boolean"];
			[var setWert:wert];
			[var setGesetzt:YES];
		//NSLog(@" variable %@ gesetzt auf %@", [var name], [var expr]);
		}
		else if ([self istZahl:wert mitPunkt:YES]) {
			[var setTyp:@"float"];
			[var setWert:wert];
			[var setGesetzt:YES];
		//NSLog(@" variable %@ gesetzt auf %@", [var name], [var expr]);
		}
		else {
			const char* charString = [wert cStringUsingEncoding:NSASCIIStringEncoding];
			int laenge = [wert length];
			if (charString[0] == 39 && charString[laenge-1] == 39) {
				[var setTyp:@"string"];
				[var setExpr:wert];
				[var setWert:wert];
			//NSLog(@" variable %@ gesetzt auf %@", [var name], [var expr]);
				[var setGesetzt:YES];
			}
			else {
				//hier pruefen, ob substring oder length
				NSString* istStringVeraenderung = [self istStringVeraenderung:wert];
				if (fehlerPassiert == YES) {
					return;
				}
				if ([istStringVeraenderung isEqualToString:@"%%%"]) {
					//bist du gueltige berechnung?
					BOOL istBerechnung = [self istBerechnung:wert];
					if (fehlerPassiert == YES) {
						return;
					}
					if(istBerechnung == YES) {
						wert = [self berechneWertVonAusdruck:wert];
						if (fehlerPassiert == YES) {
							return;
						}
						else {
							[var setExpr:wert];
							[var setWert:wert];
							[var setGesetzt:YES];
							[var setTyp:@"number"];
						//NSLog(@" variable %@ gesetzt auf %@ %d", [var name], [var expr], (int)[var gesetzt]);
						}
					}
					else {
						neuerWert = [self ersetzeVariablenInAusdruck:wert];
						if (fehlerPassiert == YES) {
							return;
						}
						
						[var setExpr:neuerWert];
					//NSLog(@"neuer Wert %@", neuerWert);
						//[var setGesetzt:YES];
						[self setzeVariable:var];
					}
				}
				else {
					[var setExpr:istStringVeraenderung];
					[var setWert:istStringVeraenderung];
					const char* charString2 = [istStringVeraenderung cStringUsingEncoding:NSASCIIStringEncoding];
					laenge = [istStringVeraenderung length];
					if (charString2[0] == 39 && charString2[laenge-1] == 39) {
						[var setTyp:@"string"];
					}
					else {
						[var setTyp:@"number"];//immer nummer, wenn nicht string
					}
					[var setGesetzt:YES];
				}

			}
			
		}
	}
}


-(Variable*)gibVariableMitName:(NSString*)variablenname mitPunkt:(BOOL)punkt
{
//NSLog(@"gib Variable mit name %@ und punkt %d", variablenname, (int)punkt);
	NSString* owner = @"";
	NSString* bisPunkt;	
	int laenge = [variablenname length];
	if (punkt == YES) {
	//NSLog(@"punkt ist yes");
		if (laenge > 9) {
			bisPunkt = [variablenname substringToIndex:9];
			if ([bisPunkt isEqualToString:@"document."]) {
				variablenname = [variablenname substringFromIndex:9];
				owner = @"vxml";
			} 
		}
		if (laenge > 7) {
			bisPunkt = [variablenname substringToIndex:7];
			if ([bisPunkt isEqualToString:@"dialog."]) {
				variablenname = [variablenname substringFromIndex:7];
				owner = @"formular";
			}
		}
	}
//NSLog(@"Variablennamen bereinigt %@, owner = %@, aktiverTag %@", variablenname, owner, aktiverTag);
	int k;
	BOOL gibtEs = NO;
	for (k = 0; k< [variablennamen count]; k++) {
	//NSLog(@"varname %@", [variablennamen objectAtIndex:k]);
		if ([variablenname isEqualToString:[variablennamen objectAtIndex:k]]) {
		//NSLog(@"gibt es");
			gibtEs = YES;
			break;
		}
	}
	if (gibtEs == YES) {
		gibtEs = NO;
		NSMutableArray* varliste;
		//richtige Variablenliste setzen
		if ([aktiverTag isEqualToString:@"filled"] || [aktiverTag isEqualToString:@"block"] || [aktiverTag isEqualToString:@"if"]) {
			if ([owner isEqualToString:@""]) {
				if ([aktiverTag isEqualToString:@"filled"]) {
					varliste = [aktiverFilled variablen];
					[varliste addObjectsFromArray:[(Formular*)aktiverZustand feldvariablen]];
				}
				else if ([aktiverTag isEqualToString:@"block"]) {
					varliste = [(Block*)aktivesFormitem variablen];
					[varliste addObjectsFromArray:[(Formular*)aktiverZustand feldvariablen]];
				}
				else {
					varliste = [aktiveEntscheidung variablen];
					[varliste addObjectsFromArray:[(Formular*)aktiverZustand feldvariablen]];
				}
			}
			if ([owner isEqualToString:@"formular"]) {
				varliste = [(Formular*)aktiverZustand variablen];
				[varliste addObjectsFromArray:[(Formular*)aktiverZustand feldvariablen]];
			}
			if ([owner isEqualToString:@"vxml"]) {
				varliste = [aktiverAutomat variablen];
			}
		}
		if ([aktiverTag isEqualToString:@"formular"]) {
			if ([owner isEqualToString:@""]) {
		//NSLog(@"formular ohne owner");
				varliste = [(Formular*)aktiverZustand variablen];
			}
			if ([owner isEqualToString:@"vxml"]) {
				varliste = [aktiverAutomat variablen];
			}
		}
		if ([aktiverTag isEqualToString:@"vxml"]) {
			varliste = [aktiverAutomat variablen];
		}
		//sofern liste nicht leer, objekt in ihr suchen
		if (varliste) {
			Variable* var;
			for (k = 0; k< [varliste count]; k++) {
				if ([variablenname isEqualToString:[[varliste objectAtIndex:k] name]]) {
					var = [varliste objectAtIndex:k];
					[varliste removeAllObjects];
					gibtEs = YES;
				//NSLog(@"var gefunden");
					break;
				}
			}
			if (gibtEs == YES) {
			//NSLog(@"returned var %@ %@", [[varliste objectAtIndex:k] name], [[varliste objectAtIndex:k] expr]);
				return var;
			}
			else {
				fehler = @"Variable existiert nicht.";
				fehlerPassiert = YES;
				return nil;
			}
		}
		else {
			fehler = @"Ungueltige Variable.";
			fehlerPassiert = YES;
			return nil;
		}

	}
	else {
	//NSLog(@"Variable existiert nicht.");
		return nil;
	}
	return nil;
}

-(NSString*)istStringVeraenderung:(NSString*)wert
{
	//remove white spaces am ende und am anfang
	const char* charString = [wert cStringUsingEncoding:NSASCIIStringEncoding];
	int k;
	for (k = [wert length]; k >= 0 ; k--) {
		if (charString[k]== ' ') {
			wert = [NSString stringWithFormat:@"%@%@", [wert substringToIndex:k], [wert substringFromIndex:k+1]];
		} else {break;}
	}
	for (k = 0; k<[wert length] ; k++) {
		if (charString[k]== ' ') {
			wert = [NSString stringWithFormat:@"%@", [wert substringFromIndex:k+1]];
			k--;
		} else {break;}
	}
	NSString* teilstring;
	BOOL nichtGesetzt = NO;
	int laenge = [wert length];
	if (laenge > 7) {
		teilstring = [wert substringFromIndex:laenge-7];
		if ([teilstring isEqualToString:@".length"]) {
			wert = [wert substringToIndex:laenge-7];
			Variable* neueVar = [self gibVariableMitName:wert mitPunkt:YES];
			if (fehlerPassiert == YES) {
				return @"";
			}
			if (!neueVar) {
				fehlerPassiert = YES;
				fehler = @"ungueltige variable";
				return @"";
			}
			if (![neueVar gesetzt]) {
				fehlerPassiert = YES;
				fehler = @"Variable hat keinen Wert";
				return @"";
			}
			int laenge;
			NSString* string = [neueVar wert];
			if ([[neueVar typ] isEqualToString:@"string"]) {
				laenge = [string length]-2;
			}
			else if ([[neueVar typ] isEqualToString:@"digits"]) {
				laenge = [string length];
			}
			else if ([[neueVar typ] isEqualToString:@"date"]) {
				laenge = [string length];
			}
			else {
				nichtGesetzt = YES;
			}
			if (nichtGesetzt == YES) {
				fehlerPassiert = YES;
				fehler = @"ungueltiger variablentyp";
				return @"";
			}
			else {
				NSString* stringlaenge = [NSString stringWithFormat:@"%d", laenge];
				return stringlaenge;
			}
		}//equal to length
		if (laenge > 15) {
			int anfang;
			int ende;
			int index = laenge-1;

			charString = [wert cStringUsingEncoding:NSASCIIStringEncoding];
			if (charString[index] == 41) {// klammer zu
				index--;
				if (charString[index] <= 57 && charString[index] >= 48) {//yazhl
					ende = [[NSString stringWithFormat:@"%c", charString[index]] intValue];
					index--;
					if (charString[index] <= 57 && charString[index] >= 48) {//zahl
						ende +=[[NSString stringWithFormat:@"%c0", charString[index]] intValue];
						index--;
					}
					if (charString[index] == 44) {//komma
						index--;
						if (charString[index] <= 57 && charString[index] >= 48) {//zahl
							anfang = [[NSString stringWithFormat:@"%c", charString[index]] intValue];
							index--;
							if (charString[index] <= 57 && charString[index] >= 48) {//zahl
								anfang +=[[NSString stringWithFormat:@"%c0", charString[index]] intValue];
								index--;
							}
							//NSLog(@"wert %@", wert);
							teilstring = [wert substringToIndex:index];
							//NSLog(@"wert %@", teilstring);
							teilstring = [teilstring substringFromIndex:index-10];
							//NSLog(@"wert %@", teilstring);
							if ([teilstring isEqualToString:@".substring"]) {
								wert = [wert substringToIndex:index-10];
								//NSLog(@"wert %@", wert);
								Variable* neueVar = [self gibVariableMitName:wert mitPunkt:NO];
							//NSLog(@"neue var mit wert %@", [neueVar expr]);
								if (fehlerPassiert == YES) {
									return @"";
								}
								if (!neueVar) {
									fehlerPassiert = YES;
									fehler = @"ungueltige variable";
									return @"";
								}
								if (![neueVar gesetzt]) {
									fehlerPassiert = YES;
									fehler = @"Variable hat keinen Wert";
									return @"";
								}
								NSString* expr = [neueVar wert];
								laenge = [expr length];

								expr = [expr substringToIndex:laenge-1];
								expr = [expr substringFromIndex:1];
								laenge = [expr length];

							//NSLog(@"expr %@ laenge %d anfang %d ende %d", expr, laenge, anfang, ende);
								if (ende < laenge && anfang >=0) {
									expr = [expr substringToIndex:ende+1];
								//NSLog(@"%@", expr);
									expr = [expr substringFromIndex:anfang];
								//NSLog(@"%@", expr);
									return expr;
								}
								else {
									fehlerPassiert = YES;
									fehler = @"ungueltiger wert";
									return @"";
								}
							}
							else {
								fehlerPassiert = YES;
								fehler = @"ungueltiger wert";
								return @"";
							}
						}//zahl
						else {
							fehlerPassiert = YES;
							fehler = @"ungueltiger wert";
							return @"";
						}
					}//komma
					else {
						fehlerPassiert = YES;
						fehler = @"ungueltiger wert";
						return @"";
					}
				}//zahl
				else {
					fehlerPassiert = YES;
					fehler = @"ungueltiger wert";
					return @"";
				}
			}//erstr buchstabe in klammer
		}//groesser 15
	}// groesser sieben
	return @"%%%";
}

-(BOOL)istBerechnung:(NSString*)expr
{
	BOOL ergebnis = YES;
	const char* charString = [expr cStringUsingEncoding:NSASCIIStringEncoding];
	int laenge = [expr length];
	int k;
	for (k = 0; k < laenge; k++) {
		if (charString[k] == ' ' || charString[k] == '.' || charString[k] == '+' || charString[k] == '-' || charString[k] == '*' || charString[k] == '/' ||
			(charString[k] <= '9' && charString[k] >= '0')) {}
			
		else {
			ergebnis = NO;
			break;
		}
	}

	return ergebnis;
}


-(NSString*)ersetzeVariablenInAusdruck:(NSString*)ausdruck
{
//NSLog(@" ersetzte variablen in ausdruck %@", ausdruck);
	NSString* neuerAusdruck;
	const char* charString = [ausdruck cStringUsingEncoding:NSASCIIStringEncoding];
	NSString* variablenname = @"";
	//NSMutableArray* gefundeneVariablen = [[NSMutableArray alloc] init];
	BOOL buchstabeGefunden = NO;
	BOOL haengeAn = NO;
	BOOL drin = NO;
	BOOL mitPunkt = NO;
	BOOL neuEntstanden = NO;
	int k;
	int endindex;
	int index;
	for (k= [ausdruck length]-1; k>=0 ; k--) {
	//NSLog(@"untersuche char %c", charString[k]);
		if ((charString[k] <= 90 && charString[k] >= 65) ||
			(charString[k] <= 122 && charString[k] >= 97) ||
			(charString[k] <= '9' && charString[k] >= '0') || (charString[k] == '.')) {
			if (buchstabeGefunden == NO) {
				index = k;
				endindex = k;
				buchstabeGefunden = YES;
			//NSLog(@"buchstabe gefunden");
			} else {
				index--;
			}
			if ((charString[k] == '.')) {
				mitPunkt = YES;
			}
			variablenname = [NSString stringWithFormat:@"%c%@", charString[k], variablenname];
		//NSLog(@"varname %@", variablenname);
			haengeAn = YES;
			drin = YES;
		}
		if(drin == NO || k==0) {
			if (haengeAn == YES) {
				BOOL istZahl = [self istZahl:variablenname mitPunkt:YES];
				if (istZahl==YES) {
				//NSLog(@" ist zahl  %@", variablenname);
					variablenname = @"";
					mitPunkt = NO;
					haengeAn = NO;
					buchstabeGefunden = NO;
				}
				if (istZahl == NO) {
				//NSLog(@" varname %@ senden, mit Punkt: %d", variablenname, (int)mitPunkt);
					Variable* ersteVar = [self gibVariableMitName:variablenname mitPunkt:mitPunkt];
					if (fehlerPassiert == YES) {
						break;
					}
					if (!ersteVar) {
					//NSLog(@"%@ hat kein owner", variablenname);
						variablenname = @"";
						mitPunkt = NO;
						haengeAn = NO;
						buchstabeGefunden = NO;
					}
					else {
					//NSLog(@"keine fehler, zeiger nicht leer, var gesetzt = %d", [ersteVar gesetzt]);
						if ([ersteVar gesetzt] == YES) {
						//NSLog(@"var gesetzt");
							neuerAusdruck = [NSString stringWithFormat:@"%@%@%@", [ausdruck substringToIndex:index], [ersteVar wert], [ausdruck substringFromIndex:endindex+1]];
							neuEntstanden = YES;
							break;
						}
						else {
						//NSLog(@"Variable ist undefiniert.");
							fehler = @"Die Variable ist undefiniert.";
							fehlerPassiert = YES;
							break;
						}
					}
				}
			}
		}
		drin = NO;
	}
	if (neuEntstanden == NO) {
		if (fehlerPassiert == NO) {
		//NSLog(@"kein neuer ausdruck entstanden");
			fehler = @"Wert nicht zulaessig";
		}
		//fehlerPassiert = YES;
	}
//NSLog(@"neuer ausdruck zurueck an setrze ausdruck %@", neuerAusdruck);
	return neuerAusdruck;
}

-(BOOL)werteBedingungAus:(NSString*)bedingung
{
	const char* charString = [bedingung cStringUsingEncoding:NSASCIIStringEncoding];
	
//remove white spaces am anfang und ende
	int k;
	for (k = [bedingung length]; k >= 0 ; k--) {
		if (charString[k]== ' ') {
			bedingung = [NSString stringWithFormat:@"%@%@", [bedingung substringToIndex:k], [bedingung substringFromIndex:k+1]];
		} else {break;}
	}
	for (k = 0; k<[bedingung length] ; k++) {
		if (charString[k]== ' ') {
			bedingung = [NSString stringWithFormat:@"%@", [bedingung substringFromIndex:k+1]];
			k--;
		} else {break;}
	}
	charString = [bedingung cStringUsingEncoding:NSASCIIStringEncoding];
	
	//suche nach <, >, == und !=
	NSString* vergleich = @"";
	int index = [bedingung length];
	for (k=0; k < [bedingung length]; k++) {
		
		if (charString[k] == '=') {
			vergleich = [NSString stringWithFormat:@"%@%c", vergleich, charString[k]];
		}
		if (charString[k] == '!') {
			if ([vergleich length] == 0) {
				vergleich = [NSString stringWithFormat:@"%@%c", vergleich, charString[k]];
			}
			else {
				fehlerPassiert = YES;
				return NO;
			}
		}
		if (charString[k] == '<') {
			if ([vergleich length] == 0) {
				vergleich = [NSString stringWithFormat:@"%@%c", vergleich, charString[k]];
			}
			else {
				fehlerPassiert = YES;
				return NO;
			}
		}
		if (charString[k] == '>') {
			if ([vergleich length] == 0) {
				vergleich = [NSString stringWithFormat:@"%@%c", vergleich, charString[k]];
			}
			else {
				fehlerPassiert = YES;
				return NO;
			}
		}
		if ([vergleich length] == 2) {
			break;
		}
		if (k == index+1) {
			break;
		}
		if ([vergleich length] == 1) {
			index = k;
		}
	}
	if ([vergleich length] == 0) {
		fehlerPassiert = YES;
		return NO;
	}
	NSArray* ausdruecke = [bedingung componentsSeparatedByString:vergleich];
NSLog(@"anzahl der ausdruecke", [ausdruecke count]);
	if ([ausdruecke count] != 2) {
		fehlerPassiert = YES;
		return NO;
	}
//NSLog(@"ausdruck 1 %@", [ausdruecke objectAtIndex:0]);
//NSLog(@"ausdruck 2 %@", [ausdruecke objectAtIndex:1]);
	NSString* ausdruck1 = [self setzeAusdruck:[ausdruecke objectAtIndex:0]];
//NSLog(@"ausdruck 1 %@", ausdruck1);
	NSString* ausdruck2 = [self setzeAusdruck:[ausdruecke objectAtIndex:1]];
//NSLog(@"ausdruck 2 %@", ausdruck2);
	if (fehlerPassiert == YES) {
		return NO;
	}
	if ([self istZahl:ausdruck1 mitPunkt:YES] == YES) {
		if ([self istZahl:ausdruck2 mitPunkt:YES] == YES) {
			float zahl1 = [ausdruck1 floatValue];
			float zahl2 = [ausdruck2 floatValue];
			if ([vergleich isEqualToString:@"=="]) {
				if (zahl1 == zahl2) {
					return YES;
				}
				else {
					return NO;
				}
			}
			if ([vergleich isEqualToString:@"<="]) {
				if (zahl1 <= zahl2) {
					return YES;
				}
				else {
					return NO;
				}
			}
			if ([vergleich isEqualToString:@">="]) {
				if (zahl1 >= zahl2) {
					return YES;
				}
				else {
					return NO;
				}
			}
			if ([vergleich isEqualToString:@"!="]) {
				if (zahl1 != zahl2) {
					return YES;
				}
				else {
					return NO;
				}
			}
			if ([vergleich isEqualToString:@"<"]) {
				if (zahl1 < zahl2) {
					return YES;
				}
				else {
					return NO;
				}
			}
			if ([vergleich isEqualToString:@">"]) {
				if (zahl1 > zahl2) {
					return YES;
				}
				else {
					return NO;
				}
			}
		}
		else {
			fehlerPassiert = YES;
			return NO;
		}
	}
	else {
		if ([ausdruck1 isEqualToString:ausdruck2]) {
			return YES;
		}
		else {
			return NO;
		}
	}
	return NO;
}


-(NSString*)berechneWertVonAusdruck:(NSString*)ausdruck
{
	BOOL abbruch = NO;
	//remove all white spaces
	const char* charString = [ausdruck cStringUsingEncoding:NSASCIIStringEncoding];
	int k;
	for (k = [ausdruck length]; k >= 0 ; k--) {
		if (charString[k]== ' ') {
			ausdruck = [NSString stringWithFormat:@"%@%@", [ausdruck substringToIndex:k], [ausdruck substringFromIndex:k+1]];
		}
	}
//NSLog(@"%@", ausdruck);
	//divide by +, * und /
	NSMutableArray* operationen = [[NSMutableArray alloc] init];
	NSMutableArray* zahlen = [[NSMutableArray alloc] init];
	NSString* zahl = @"";
	charString = [ausdruck cStringUsingEncoding:NSASCIIStringEncoding];
	
	//int j;
	for (k = [ausdruck length]-1; k >= 0 ; k--) {
		if (charString[k]== '+' || charString[k]== '*' || charString[k]== '/') {
			if ([zahl length] == 0) {
				fehler = @"Ausdruck kann nicht berechnet werden.";
				abbruch = YES;
				break;
			}
			else {
				[zahlen addObject:zahl];
				if (charString[k]== '+') {
					[operationen addObject:@"+"];
				}
				else if (charString[k]== '*') {
					[operationen addObject:@"*"];
				}
				else {
					[operationen addObject:@"/"];
				}
				zahl = @"";
			}
		}
		else {
			zahl = [NSString stringWithFormat:@"%c%@", charString[k], zahl];
		}
	}
	if (abbruch == YES) {
	
	
		return @"ERROR";
	}
	if ([zahl length] == 0) {
		
		fehler = @"Ausdruck kann nicht berechnet werden.";
		return @"ERROR";
	}
	else {
		[zahlen addObject:zahl];
	}
	//auf punkt untersuchen und minus
	int l;
	for (l = [zahlen count]-1; l >=0 ; l--) {
		
		zahl = [zahlen objectAtIndex:l];
	//NSLog(@"Zahl %@", zahl);
		charString = [zahl cStringUsingEncoding:NSASCIIStringEncoding];
		int m;
		BOOL punkt = NO;
		BOOL letzterWarZahl = NO;
		//punkt
		for (m=[zahl length]-1; m >= 0 ;m--) {
			
			
			if (charString[m] == '.') {
				if (punkt == YES) {
					fehler = @"Ausdruck kann nicht berechnet werden.";
				//NSLog(@"abbruch == %d", (int)abbruch);
					abbruch = YES;
				//NSLog(@"abbruch == %d", (int)abbruch);
					break;
				}
				else if (letzterWarZahl == NO) {
					fehler = @"Ausdruck kann nicht berechnet werden.";
					abbruch = YES;
					break;
				}
				punkt = YES;
			}
			else {
				letzterWarZahl = YES;
			}
		}
		if (abbruch == YES) {
			break;
		}
		//minus
		//float einFloat = 0;
		NSString* neuerZaehlenwert;
		BOOL minusGehabt = NO;
		NSMutableArray* neueZahlenListe= [[NSMutableArray alloc] init];
		for (m=[zahl length]-1; m >= 0 ;m--) {
		//NSLog(@"untersuche %c", charString[m]);
			
			if (charString[m] == '-') {
				minusGehabt = YES;
			//NSLog(@"geht rein, minusgehabt auf %d", (int)minusGehabt);
				if (m != [zahl length]-1) {
					
					neuerZaehlenwert = [zahl substringFromIndex:m];
				//NSLog(@"neuer Zahlenwert %@", neuerZaehlenwert);
					//[zahlen removeObjectAtIndex:l];
					[neueZahlenListe addObject:neuerZaehlenwert];
					[operationen insertObject:@"+" atIndex:l];
					//[zahlen removeObjectAtIndex:l];
					//[]
					//einFloat += [[zahl substringFromIndex:m] floatValue];
					//NSLog(@"%f", einFloat);
				}
				else {
					fehler = @"Ausdruck kann nicht berechnet werden.";
					abbruch = YES;
					break;
				}
				zahl = [zahl substringToIndex:m];
			}
			if (m==0) {
			//NSLog(@"m==0");
				if (minusGehabt == YES) {
				//NSLog(@"minusGehabt == YES");
					[zahlen removeObjectAtIndex:l];
					[neueZahlenListe addObject:zahl];
					int p;
					for (p = [neueZahlenListe count]-1; p >= 0 ; p--) {
						[zahlen insertObject:[neueZahlenListe objectAtIndex:p] atIndex:l];
					}
				//NSLog(@"neuer Zahlenwert %@", zahl);
				//NSLog(@"anz zahlen %d, azahl op %d", [zahlen count], [operationen count]);
					int bla;
					for (bla = 0; bla < [operationen count]; bla++) {
					//NSLog(@"%@",[operationen objectAtIndex:bla]);
					}
					for ( bla = 0; bla < [zahlen count]; bla++) {
					//NSLog(@"%@",[zahlen objectAtIndex:bla]);
					}
				}
			}
		}
		if (abbruch == YES) {
			break;
		}
		//if ([zahl length] == 0) {
		//	abbruch == YES;
			//einFloat += [zahl floatValue];
			//NSLog(@"%f", einFloat);
		//}
		//zahl = [NSString stringWithFormat:@"%f", einFloat];
		
		//[zahlen insertObject:zahl atIndex:l];
	}
	//NSLog(@"aus liste %@", [zahlen objectAtIndex:0]);
	if (abbruch == YES) {
	
		return @"ERROR";
	}
	//mal suchen
	int n;
	NSString* op;
	NSString* zahlString1;
	NSString* zahlString2;
	float neueZahl;
	for (n = [operationen count]-1; n >=0 ;n--) {
		op = [operationen objectAtIndex:n];
		if ([op isEqualToString:@"*"] || [op isEqualToString:@"/"]) {
			zahlString1 = [zahlen objectAtIndex:n];
		//NSLog(@"zahlString1 %@", zahlString1);
			zahlString2 = [zahlen objectAtIndex:n+1];
		//NSLog(@"zahlString2 %@", zahlString2);
			if ([op isEqualToString:@"*"]) {
				neueZahl = [zahlString1 floatValue] * [zahlString2 floatValue];
			} else {
				neueZahl = [zahlString2 floatValue] / [zahlString1 floatValue];
			}
		//NSLog(@"%f", neueZahl);
			[zahlen removeObjectAtIndex:n+1];
			[zahlen removeObjectAtIndex:n];
			zahlString1 = [NSString stringWithFormat:@"%f", neueZahl];
			[zahlen insertObject:zahlString1 atIndex:n];
			[operationen removeObjectAtIndex:n];


		}
	}
//NSLog(@"vor plusberechnung");
	int bla;
	for (bla = 0; bla < [operationen count]; bla++) {
	//NSLog(@"%@",[operationen objectAtIndex:bla]);
	}
	for ( bla = 0; bla < [zahlen count]; bla++) {
	//NSLog(@"%@",[zahlen objectAtIndex:bla]);
	}
	// plus suchen
	while ([zahlen count] > 1) {
	//NSLog(@"anz zahlen %d", [zahlen count]);
		zahlString1 = [zahlen objectAtIndex:0];
		zahlString2 = [zahlen objectAtIndex:1];
		neueZahl = [zahlString1 floatValue] + [zahlString2 floatValue];
		[zahlen removeObjectAtIndex:1];
		[zahlen removeObjectAtIndex:0];
		zahlString1 = [NSString stringWithFormat:@"%f", neueZahl];
		[zahlen insertObject:zahlString1 atIndex:0];
	}
	[operationen autorelease];
	[zahlen autorelease];
	return [zahlen objectAtIndex:0];
	
}




#pragma mark Dokument Pflichtmethoden
- (NSString *)windowNibName
{
    // Override returning the nib file name of the document
    // If you need to use a subclass of NSWindowController or if your document supports multiple NSWindowControllers, you should remove this method and override -makeWindowControllers instead.
    return @"MyDocument";
}

- (void)windowControllerDidLoadNib:(NSWindowController *) aController
{
    [super windowControllerDidLoadNib:aController];
	
    NSToolbar* toolbar;
	toolbar = [[NSToolbar alloc] initWithIdentifier:@"defaultToolbar"];
	[toolbar setDelegate:self];
	[[aController window] setToolbar:toolbar];
	[toolbar release];
	[codeView setFont:[NSFont fontWithName:@"Monaco" size:10]];

	// dieser codeabschnitt bewirkt, dass die codeview toll ist mit scrollern und so....
	// quelle: http://www.idevapps.com/forum/showthread.php?t=6297
	
		const float LargeNumberForText = 1.0e7;

		NSScrollView *scrollView = [codeView enclosingScrollView];
		[scrollView setHasVerticalScroller:YES];
		[scrollView setHasHorizontalScroller:YES];
		[scrollView setAutoresizingMask:(NSViewWidthSizable | NSViewHeightSizable)];

		NSTextContainer *textContainer = [codeView textContainer];
		[textContainer setContainerSize:NSMakeSize(LargeNumberForText, LargeNumberForText)];
		[textContainer setWidthTracksTextView:NO];
		[textContainer setHeightTracksTextView:NO];

		[codeView setMaxSize:NSMakeSize(LargeNumberForText, LargeNumberForText)];
		[codeView setHorizontallyResizable:YES];
		[codeView setVerticallyResizable:YES];
		[codeView setAutoresizingMask:NSViewNotSizable];


	[syntaxfehlerView setFont:[NSFont fontWithName:@"Monaco" size:10]];
	[syntaxfehlerView setTextColor:[NSColor redColor]];
	[modelfehlerView setFont:[NSFont fontWithName:@"Monaco" size:10]];
	[dialogView setFont:[NSFont fontWithName:@"Helvetica" size:11]];
	[dialogView setTextColor:[NSColor redColor]];
	[dialogView setDelegate:self];
	[codeView setString:code];
	[code release];
	//[codeView setString: @"<vxml>\n\n//Fuege hier die Formulare und die Menues ein.\n\n</vxml>"];
	[modelView setAutomat:automat];
	[modelView setDokument:self];
}

- (NSData *)dataRepresentationOfType:(NSString *)aType
{	
	NSMutableData* data = [[NSMutableData alloc] init];
	NSKeyedArchiver* archiver = [[NSKeyedArchiver alloc] initForWritingWithMutableData:data];
	
	[archiver encodeObject:[codeView string] forKey:@"inES code"];
	[archiver encodeObject:automat forKey:@"inES Automat"];
	
	[archiver finishEncoding];
	
	[data autorelease];
	[archiver autorelease];
	
	return data;
}

/*
- (BOOL)loadDataRepresentation:(NSData *)data ofType:(NSString *)aType
{
    // Insert code here to read your document from the given data.  You can also choose to override -loadFileWrapperRepresentation:ofType: or -readFromFile:ofType: instead.
    
    // For applications targeted for Tiger or later systems, you should use the new Tiger API readFromData:ofType:error:.  In this case you can also choose to override -readFromURL:ofType:error: or -readFromFileWrapper:ofType:error: instead.
    
    return YES;
}*/



@end
